      subroutine dosubs(
     & orgdim,orgmax,orgstr,orgmod,
     & trndim,trnmax,trnstr,
     & bufdim,bufmax,bufstr,
     & bufmx2,bufst2,fnddat,subct)

C     Replace orgstr by trnstr in buffer bufstr.  Or just locate an
C     occurrence of orgstr.

      implicit none

C input:

C     declared original string size
      integer orgdim
C     actual original string size
      integer orgmax
C     original string
      character*1 orgstr(orgdim)
C     modifiers
      character*1 orgmod(orgdim)

C     declared translation string size
      integer trndim
C     actual translation string size, or coded command if negative
      integer trnmax
C     translation string
      character*1 trnstr(trndim)

C     declared buffer string size
      integer bufdim
C     actual buffer string size
      integer bufmax
C     buffer
      character*1 bufstr(bufdim)

C output:

C     actual output buffer string size, unless we are just selecting
      integer bufmx2
C     output buffer, unless we are just selecting
      character*1 bufst2(bufdim)
C     fnddat(1) is the counter of matches found.  If we are just selecting,
C     fnddat(2) is set to the start of the -trnmax-th occurrence of the
C     original string, and fnddat(3) the end, or to the last found
C     occurrence, if there are less than -trnmax.
      integer fnddat(3)
C     counter of nontrivial substitutions done
      integer subct

C local:

C     buffer positions
      integer buf0,buf1,buf

C     position in the orginal string
      integer org

C     position in the translation string
      integer trn

C     ascii values of single and double quotes
      integer asc_q,asc_dq
      parameter (asc_q=39,asc_dq=34)
C     ascii values of 0, 9, +, and -
      integer asc_0,asc_9,asc_p,asc_m
      parameter (asc_0=48,asc_9=57,asc_p=43,asc_m=45)
C     ascii values of tab, space, carriage return, and linefeed
      integer asc_t,asc_s,asc_cr,asc_lf
      parameter (asc_t=9,asc_s=32,asc_cr=13,asc_lf=10)
C     ascii values of a, z, A, and Z
      integer asc_a,asc_z,asc_ca,asc_cz
      parameter (asc_a=97,asc_z=122,asc_ca=65,asc_cz=90)
C     ascii value of orgstr
      integer iorg
C     ascii index
      integer iasc

C     list of characters that matches (256 is end of file)
      integer good(0:256)
C     whether we need to reset array good totally
      integer reset
C     if not, the values to reset to 0
      integer iset1,iset2

C     list of replacement characters for translation specials
      integer repchr(0:255)

C     specials for the translation that just select
      character*5 trnspn
      data trnspn/'cfsv^'/
C     mode (0: normal, 1: computed translation, 2: select only)
      integer trnmod
C     commands for encoding, replacement, and capitalization
      integer cmd_e,cmd_r,cmd_x
      parameter (cmd_e=256,cmd_r=257,cmd_x=258)

C     case sensitivity
      integer docase
C     NOT is active
      integer havnot
C     ANY is active
      integer havany
C     whether we are in a group
      integer group
C     whether we have a match
      integer match

C     whether we have a change
      integer change
C     precomputed value
      integer chang0

C executable:

C     set array good to all false
      do 10 iasc=0,256
         good(iasc)=0
 10   continue

C     handle negative trnmax
      trnmod=0
      if(trnmax.lt.0)then
         if(index(trnspn,trnstr(1)).gt.0)then
            trnmod=2
         else
            trnmod=1
             do 200 iasc=0,255
               repchr(iasc)=iasc
 200        continue
            if(trnstr(1).eq.'u')then
               do 210 iasc=asc_a,asc_z
                  repchr(iasc)=iasc-32
 210           continue
            else if(trnstr(1).eq.'l')then
               do 220 iasc=asc_ca,asc_cz
                  repchr(iasc)=iasc+32
 220           continue
            else if(trnstr(1).eq.'x')then
               do 230 iasc=asc_a,asc_z
                  repchr(iasc)=cmd_x
 230           continue
               do 240 iasc=asc_ca,asc_cz
                  repchr(iasc)=cmd_x
 240           continue
            else if(trnstr(1).eq.'e')then
               repchr(ichar(trnstr(2)))=cmd_e
               chang0=1
               if(trnmax.eq.-3)then
                  if(trnstr(2).eq.trnstr(3))chang0=0
               endif
            else if(trnstr(1).eq.'r')then
               repchr(ichar(trnstr(2)))=cmd_r
               chang0=1
               if(trnmax.eq.-3)then
                  if(trnstr(2).eq.trnstr(3))chang0=0
               endif
            else
               call fatal('Program error in dosubs')
            endif
         endif
      endif

C     initialize the find and substitution counts
      fnddat(1)=0
      subct=0

C     initialize output buffer length
      bufmx2=0

C     initialize the positions in array good to reset
      iset1=0
      iset2=0

C     initialize case sensitivity
      docase=1

C     initialize the starting position of a potential substitution
      buf0=0

C     next starting position of a potential match (bufmax+1 is EOF)
 1000 buf0=buf0+1
      if(buf0.gt.bufmax+1)goto 9000

C     copy the character provisionally to the output buffer
      bufmx2=bufmx2+1
      if(buf0.le.bufmax)then
         if(bufmx2.gt.bufdim)goto 9900
         bufst2(bufmx2)=bufstr(buf0)
      endif

C     compare the coming string with the desired original

C     initialize the comparison indices
      buf1=buf0-1
      org=0

C     next (havnot,havany,good) to compare with
 2000 havnot=0
      havany=0
      group=0
      reset=0

C     continue reading (havnot,havany,good)
 2010 org=org+1
      if(org.gt.orgmax)goto 8000

C     process the character
      iorg=ichar(orgstr(org))
      if(iorg.eq.0)then
C        plain ascii nul
         if(orgmod(org).eq.char(0))then
            good(0)=1
            iset1=0
            goto 3900
C        case sensitivity
         else if(orgmod(org).eq.'=')then
            docase=1
            goto 2010
         else if(orgmod(org).eq.'-')then
            docase=0
            goto 2010
C        not
         else if(orgmod(org).eq.'~')then
            havnot=1
            goto 2010
C        any
         else if(orgmod(org).eq.'?')then
            havany=1
            goto 2010
C        start of group
         else if(orgmod(org).eq.'&')then
            group=1
            reset=1
            goto 2010
C        end of group
         else if(orgmod(org).eq.'*')then
            group=0
            goto 4000
         endif
C        commands describing multiple characters and EOF
         if(orgmod(org).eq.'''')then
            good(asc_q)=1
            good(asc_dq)=1
            iset1=asc_q
            iset2=asc_dq
         else if(orgmod(org).eq.'_')then
            good(asc_s)=1
            good(asc_t)=1
            iset1=asc_s
            iset2=asc_t
         else if(orgmod(org).eq.'+')then
            good(asc_s)=1
            good(asc_t)=1
            good(asc_cr)=1
            good(asc_lf)=1
            reset=1
         else if(orgmod(org).eq.'5')then
            do 3100 iasc=asc_0,asc_9
               good(iasc)=1
 3100       continue
            reset=1
         else if(orgmod(org).eq.'6')then
            good(asc_p)=1
            good(asc_m)=1
            iset1=asc_p
            iset2=asc_m
         else if(orgmod(org).eq.'a')then
            do 3200 iasc=0,255
               good(iasc)=1
 3200       continue
            reset=1
         else if(orgmod(org).eq.'l')then
            do 3300 iasc=asc_a,asc_z
               good(iasc)=1
 3300       continue
            if(docase.eq.0)then
               do 3350 iasc=asc_ca,asc_cz
                  good(iasc)=1
 3350          continue
            endif
            reset=1
         else if(orgmod(org).eq.'u')then
            do 3400 iasc=asc_ca,asc_cz
               good(iasc)=1
 3400       continue
            if(docase.eq.0)then
               do 3450 iasc=asc_a,asc_z
                  good(iasc)=1
 3450          continue
            endif
            reset=1
         else if(orgmod(org).eq.']')then
            good(256)=1
            iset1=256
         else
            print*,iorg,ichar(orgmod(org))
            call fatal('Program error in dosubs')
         endif
      else
C        set the good character
         good(iorg)=1
         iset1=iorg
         if(docase.eq.0)then
            if(iorg.ge.asc_a)then
               iset2=iorg-32
               if(iorg.le.asc_z)good(iset2)=1
            else if(iorg.ge.asc_ca .and. iorg.le.asc_cz)then
               iset2=iorg+32
               good(iset2)=1
            endif
         endif
      endif
 3900 continue

C     if in a group, go read the next character
      if(group.eq.1)goto 2010

C     do the comparison

 4000 continue

      if(havany.eq.1)then

C        compare the pending characters with the allowed ones
 4100    if(buf1.lt.bufmax)then
            match=good(ichar(bufstr(buf1+1)))
            if(havnot.eq.1)match=1-match
            if(match.eq.1)then
               buf1=buf1+1
               goto 4100
            endif
         endif
         match=1

      else

C        compare the pending character with the allowed ones
         if(buf1.ge.bufmax)then
            match=good(256)
         else
            buf1=buf1+1
            match=good(ichar(bufstr(buf1)))
         endif
         if(havnot.eq.1)match=1-match

      endif

C     reset array good and go read the next comparison
      if(reset.eq.0)then
         good(iset1)=0
         good(iset2)=0
      else
         do 4900 iasc=0,256
            good(iasc)=0
 4900    continue
      endif
      if(match.eq.1)goto 2000
      goto 1000

C     substitute the translation

C     increment the find counter
 8000 fnddat(1)=fnddat(1)+1

C     remove the provisional buf0 character
      bufmx2=bufmx2-1

C     copy the translation into the output buffer
      change=0
      if(trnmod.eq.0)then
         if(trnmax.ne.buf1-buf0+1)change=1
         do 8500 trn=1,trnmax
            bufmx2=bufmx2+1
            if(bufmx2.gt.bufdim)goto 9900
            bufst2(bufmx2)=trnstr(trn)
            if(change.eq.0)then
               if(trnstr(trn).ne.bufstr(buf0+trn-1))change=1
            endif
 8500    continue
      else if(trnmod.eq.1)then
         buf=buf0
 8510    if(buf.gt.buf1)goto 8600
         iasc=ichar(bufstr(buf))
         if(repchr(iasc).lt.256)then
            if(repchr(iasc).ne.iasc)change=1
            bufmx2=bufmx2+1
            if(bufmx2.gt.bufdim)goto 9900
            bufst2(bufmx2)=char(repchr(iasc))
         else if(repchr(iasc).eq.cmd_x)then
            bufmx2=bufmx2+1
            if(bufmx2.gt.bufdim)goto 9900
            if(iasc.ge.asc_a .and. iasc.le.asc_z)then
               iasc=iasc-32
               change=1
            endif
            bufst2(bufmx2)=char(iasc)
            if(iasc.ge.asc_ca .and. iasc.le.asc_cz)then
               do 8520 iasc=asc_ca,asc_cz
                  repchr(iasc)=iasc
                  repchr(iasc+32)=iasc+32
 8520          continue
            endif
         else if(repchr(iasc).eq.cmd_r)then
            if(chang0.ne.0)change=1
            do 8550 trn=3,-trnmax
               bufmx2=bufmx2+1
               if(bufmx2.gt.bufdim)goto 9900
               bufst2(bufmx2)=trnstr(trn)
 8550       continue
         else if(repchr(iasc).eq.cmd_e)then
            bufmx2=bufmx2+1
            if(bufmx2.gt.bufdim)goto 9900
            bufst2(bufmx2)=char(iasc)
            if(buf1-buf+1.lt.-trnmax-2)goto 8570
            do 8560 trn=3,-trnmax-1
               if(trnstr(trn).ne.bufstr(buf+trn-2))goto 8570
 8560       continue
            if(chang0.ne.0)change=1
            bufst2(bufmx2)=trnstr(-trnmax)
            buf=buf-trnmax-3
 8570       continue
         endif
         buf=buf+1
         goto 8510
 8600    continue
      else
         if(fnddat(1).le.-trnmax)fnddat(2)=buf0
         if(fnddat(1).le.-trnmax)fnddat(3)=buf1
         if(fnddat(1).eq.-trnmax)return
      endif
      subct=subct+change

C     set the new position in bufstr to proceed from
      if(buf1.ge.buf0)then
         buf0=buf1
      else
         bufmx2=bufmx2+1
         if(buf0.le.bufmax)then
            if(bufmx2.gt.bufdim)goto 9900
            bufst2(bufmx2)=bufstr(buf0)
         endif
      endif

C     go do the remaining string
      goto 1000

C     remove the virtual end-of-file character
 9000 bufmx2=bufmx2-1

C     set the final location as a zero length string at eof if not found
      if(trnmod.eq.2)then
         if(trnmax.ne.-123456789 .or. fnddat(1).le.0)then
            fnddat(2)=bufmax+1
            fnddat(3)=bufmax
         endif
      endif

C     all done
      return
 9900 call fatali('Out of storage.  Buffer size is ',bufdim)
      end
