      subroutine inibuf

c     Initializes the internal io buffer

c     avoid typos
      implicit none

c common:

c     io buffer dimension (change two places)
      integer iobufd
      parameter (iobufd=20000)
c     defined length of the io buffer and the current position
      integer iobufl,iobufp
c     io buffer
      character*(iobufd) iobuf
      common/ciobuf/iobufl,iobufp,iobuf

c executable:

c     buffer is empty
      iobufl=0
      iobufp=0

      return
      end



      subroutine setbuf(str1,str2)

c     Puts str1 and str2 in the internal io buffer separated by a linefeed

c     avoid typos
      implicit none

c input:

c     strings to put in the buffer
      character*(*) str1
      character*(*) str2

c common:

c     io buffer dimension (change two places)
      integer iobufd
      parameter (iobufd=20000)
c     defined length of the io buffer and the current position
      integer iobufl,iobufp
c     io buffer
      character*(iobufd) iobuf
      common/ciobuf/iobufl,iobufp,iobuf

c local:

c     string index
      integer i

c executable:

c     put str1 in the buffer
      i=len(str1)
      if(i+2.gt.iobufd)call fatal('Internal I/O buffer size exceeded')
      iobuf(1:i)=str1

c     put the linefeed in it
      iobufl=i+1
      iobuf(iobufl:iobufl)=char(10)

c     put str2 in it
      i=len(str2)
      if(iobufl+i+1.gt.iobufd)
     & call fatal('Internal I/O buffer size exceeded')
      iobuf(iobufl+1:iobufl+i)=str2
      iobufl=iobufl+i+1
      iobuf(iobufl:iobufl)=char(10)

c     set the position
      iobufp=0

      return
      end



      subroutine getbuf(chr,stat)

c     Gets the next character from the common io buffer.

c     Returns stat=-1 when empty.

c     avoid typos
      implicit none

c output:

c     read character
      character*1 chr

c     error status
      integer stat

c common:

c     io buffer dimension (change two places)
      integer iobufd
      parameter (iobufd=20000)
c     defined length of the io buffer and the current position
      integer iobufl,iobufp
c     io buffer
      character*(iobufd) iobuf
      common/ciobuf/iobufl,iobufp,iobuf

c executable:

      stat=-1
      if(iobufp.ge.iobufl)return

      stat=0
      iobufp=iobufp+1
      chr=iobuf(iobufp:iobufp)

      return
      end
