      subroutine subbn0(
     & subfil,infil,outfil,verbos)

c     The actual, subroutine implementation, of subbin.

c     avoid typos
      implicit none

c input

c     originals/substitutions file
      character*(*) subfil
c     input file
      character*(*) infil
c     output file
      character*(*) outfil
c     verbosity (0: none, 1: summary, 2 details)
      integer verbos

c common data from dopair

c     declared substring selection levels
      integer levdim
      parameter (levdim=1000)
c     actual substring selection level
      integer lev
c     available bufdim at each level
      integer bufdml(0:levdim)
c     start of the post-selection string
      integer post(levdim)

c     after a successfull \f#, the #-th occurrence is from fnddat(2) to (3)
      integer fnddat(3)

c     total substitutions
      integer subtot
c     total found strings
      integer fndtot
c     total missed substitutions
      integer subnot
c     total missed searches
      integer fndnot
c     previous value of subtot at \x command
      integer oldsct

      common/cmpair/lev,bufdml,post,
     & fnddat,
     & subtot,fndtot,subnot,fndnot,oldsct

c local

c     declared primary and secondary file buffer sizes
      integer bufdim
      parameter (bufdim=900000)
c     actual file buffer sizes
      integer bufmax,bufmx2
c     file buffers
      character*1 bufstr(bufdim),bufst2(bufdim)

c     declared original string size
      integer orgdim
      parameter (orgdim=100000)
c     actual original string size
      integer orgmax
c     original string
      character*1 orgstr(orgdim)
c     modifiers
      character*1 orgmod(orgdim)

c     declared translation string size
      integer trndim
      parameter (trndim=orgdim)
c     actual translation string size
      integer trnmax
c     translation string
      character*1 trnstr(trndim)

c     declared memory string size
      integer memdim
      parameter (memdim=orgdim)
c     actual memory size
      integer memmax
c     memory string
      character*1 memstr(memdim)
      save memstr,memmax

c     counter of matches found for this pair
      integer fndct
c     counter of nontrivial substitutions done for this pair
      integer subct

c     whether we use buffer 2
      integer use2

c executable

c     initialize
      call inibuf

c     read the file to change into storage
      call readfu(infil,len(infil),2,bufdim,bufmax,bufstr)
      use2=0

c     open the orginal/translation table file
      goto 900
 880  close(1,err=890)
      goto 900
 890  call fatal('Unable to close the substitution file?!')
 900  call openru(subfil,1)

c     start point for the next string translation
 1000 continue

c     do the translation
      call dopair(
     & 0,max(0,verbos-1),1,subfil,
     & orgdim,orgmax,orgstr,orgmod,trndim,trnmax,trnstr,
     & memdim,memmax,memstr,
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,
     & fndct,subct,
     & *9000,*880)

c     next translation
      goto 1000

c     write the new file
 9000 if(subtot.gt.0)then
         if(use2.eq.0)then
            call writfu(outfil,len(outfil),3,bufdim,bufmax,bufstr)
         else
            call writfu(outfil,len(outfil),3,bufdim,bufmx2,bufst2)
         endif
      endif

c     print statistics
      if(verbos.gt.0)then
         print9110,fndtot,subtot,fndnot,subnot
 9110    format(
     &    'subbin: Total strings found:  ',i10/
     &    '        Total strings changed:',i10/
     &    '        String find failures: ',i10/
     &    '        Unchanged strings:    ',i10)
      endif

c     all done
      return
      end
