#!/bin/csh -f

if !($?L2HTOP) then
   echo "*** variable L2HTOP is not set"
   goto err
endif
if !(-d $L2HTOP/l2hsup) then
   echo "*** directory $L2HTOP/l2hsup does not exist"
   goto err
endif

# Fakes the operation of ppmquant, (which gets the colors all wrong,)
# using pnmremap and pnmcolormap.

# Usage (ORDER AND CASE SENSITIVE):
#    ppmquant -floyd number_of_colors infile > outfile
# where -floyd is ignored and can be omitted.

# check whether we have valid arguments
if ("$1" == "") goto errarg
if ("$1" == "-quiet") shift
if ("$1" == "-floyd") shift
if ("$1" == "") goto errpar
if ("$2" == "") goto errpar
if !(-f $2) goto errfil

# create a map file
$L2HTOP/l2hsup/pnmcolormap $1 $2 > tmp.map
if ($status >= 1) goto errmap

# create a remapped file on standard output
$L2HTOP/l2hsup/pnmremap -map=tmp.map $2
if ($status >= 1) goto errremap

goto end
errarg:
echo "ppmquant: missing arguments; run me with rb.exe" > $L2HTOP/temp/rb.err
goto paus
errpar:
echo "ppmquant: invalid arguments $1 $2" > $L2HTOP/temp/rb.err
goto paus
errfil:
echo "ppmquant: file $2 does not exist" > $L2HTOP/temp/rb.err
goto paus
errmap:
echo "ppmquant: error running pnmcolormap $1 $2" > $L2HTOP/temp/rb.err
goto paus
errremap:
echo "ppmquant: error running pnmremap -map=tmp.map $2" > $L2HTOP/temp/rb.err
paus:
set ans="$<"
end:
