      subroutine askcol(prompt,def,color)

c     Ask for a color and return it in hex format.  The default can
c     either be blank or a valid uppercase 6 digit hex which is NOT
c     checked.

c     avoid typos
      implicit none

c input

c     prompt to use
      character*(*) prompt

c     default color (blank for no default, otherwise a valid uppercase hex)
      character*(*) def

c output

c     selected color in hex format; may be blank if the default is blank.
      character*6 color

c local

c     input line
      character*80 line
      integer linelt

c     numerical color value
      integer val
      real rval
      character*20 cval
      integer cvall

c     hex characters
      character*16 hex
      parameter (hex='0123456789ABCDEF')

c     indices
      integer i,i1,i2

c executable

      call type('askcol')

      goto 20
 10   call out('** Invalid color.  Enter a question mark for help')
 20   linelt=len(prompt)
      if(linelt.gt.66)call fatal('askcol: Prompt too long')
      line(1:linelt)=prompt
      line(linelt+1:80)=':'
      if(def.ne.' ')then
         call encint((index(hex,def(1:1))-1)*16+index(hex,def(2:2))-1,
     &    cvall,cval)
         line(linelt+3:linelt+2+cvall)=cval(1:cvall)
         linelt=linelt+2+cvall
         call encint((index(hex,def(3:3))-1)*16+index(hex,def(4:4))-1,
     &    cvall,cval)
         line(linelt+1:linelt+1+cvall)=','//cval(1:cvall)
         linelt=linelt+1+cvall
         call encint((index(hex,def(5:5))-1)*16+index(hex,def(6:6))-1,
     &    cvall,cval)
         line(linelt+1:linelt+1+cvall)=','//cval(1:cvall)
      endif
      call in2(line,linelt)
      if(line(1:linelt).eq.' ')then
         if(def.eq.' ')return
         goto 10
      endif
      if(line(1:linelt).eq.'rgb?')then
         call type('rgbex')
         goto 20
      endif
      if(index(line(1:linelt),'?').gt.0)then
         call type('hlpcol')
         goto 20
      endif
      if(linelt.lt.5)goto 10
      if(index(line(1:linelt),'o').gt.0 .or.
     & index(line(1:linelt),'O').gt.0)then
         call out('** Invalid color. Mistyped an "o" for a zero?')
         goto 20
      endif
      if(index(line(1:linelt),',').gt.0)then
         if(index(line(1:linelt),'.').gt.0)then
            call out('** Invalid color. Mistyped a point for a comma?')
            goto 20
         endif
         if(index(line(1:linelt),'-').gt.0)goto 10
         i1=1
         i2=index(line(1:linelt),',')-1
         if(i2.lt.i1 .or. i2.ge.linelt-1)goto 10
         call readvl(line(i1:i2),rval,*10)
         val=nint(rval)
         if(val.lt.0 .or. val.gt.255)goto 10
         color(1:1)=hex(val/16+1:val/16+1)
         color(2:2)=hex(mod(val,16)+1:mod(val,16)+1)
         i1=i2+2
         i2=index(line(i1:linelt),',')+i1-2
         if(i2.lt.i1 .or. i2.ge.linelt-1)goto 10
         call readvl(line(i1:i2),rval,*10)
         val=nint(rval)
         if(val.lt.0 .or. val.gt.255)goto 10
         color(3:3)=hex(val/16+1:val/16+1)
         color(4:4)=hex(mod(val,16)+1:mod(val,16)+1)
         call readvl(line(i2+2:linelt),rval,*10)
         val=nint(rval)
         if(val.lt.0 .or. val.gt.255)goto 10
         color(5:5)=hex(val/16+1:val/16+1)
         color(6:6)=hex(mod(val,16)+1:mod(val,16)+1)
      else
         if(linelt.eq.6)then
            color=line(1:6)
         else if(linelt.eq.7 .and. line(1:1).eq.'#')then
            color=line(2:7)
         else
            goto 10
         endif
         do 30 i=1,6
            if(color(i:i).ge.'a' .and. color(i:i).le.'z')
     &       color(i:i)=char(ichar(color(i:i))-32)
            if(index(hex,color(i:i)).le.0)goto 10
 30      continue
      endif

      return
      end
