      subroutine asksub(subdir,class,prompt,def,sub,subl)

c     Asks for a HTML substitution.  If the user left the default, subl will
c     return as zero.  If the user entered a blank line, and the default is
c     not blank, subl will be 1 and sub(1:1) blank.

c     If subl is 1 and sub(1:1) a question mark, provide help and reenter.

c     avoid typos
      implicit none

c input

c     nonzero for web pages in a subdirectory
      integer subdir

c     the class string for a href, starting with a blank
      character*(*) class

c     prompt to use, no colon
      character*(*) prompt

c     default (if the default is empty, use a single space here.)
      character*(*) def

c output

c     substitution
      character*(*) sub

c     length of the substitution, zero for unchanged
      integer subl

c local

c     length of the prompt
      integer prompl

c     length of the class
      integer classl

c     length of the default
      integer defl

c     declared length of the substitution
      integer subd

c     number of coded characters
      integer codmax
      parameter (codmax=5)
c     coded  character index
      integer cod
c     coded characters
      character*(codmax) codchr
      data codchr/'&<>"\\'/
c     encoded strings
      character*6 codstr(codmax)
      data codstr/'&amp;','&lt;','&gt;','&quot;','&#92;'/
c     length of the strings
      integer codlt

c     nonzero if we are in an HTML tag
      integer tag

c     nonzero if we are in a hotlink
      integer link

c     input line
      character*80 line
      integer linelt
      character*80 line2
      integer line2l

c     saved line
      character*80 savlin
      integer savllt

c     character indices
      integer ic,ic2

c     character
      character*1 chr

c executable

 10   format(a,a,a)

c     set the class string length
      classl=len(class)

c     set the declared subtitution length
      subd=len(sub)

c     initialize the prompt line
      prompl=len(prompt)
      if(prompl.gt.70)call out('*** asksub: prompt too long!')
      line(1:prompl+2)=prompt//':?'
      linelt=prompl+2

c     decode the default and add to the line
      defl=len(def)
      ic=0
c     next encoded character
 200  ic=ic+1
      if(ic.gt.defl)goto 290
      if(linelt.ge.79)then
         line(77:79)='...'
         goto 290
      endif
      chr=def(ic:ic)
c     decode all known sequences
      if(chr.eq.'&')then
         do 250 cod=1,codmax
            codlt=index(codstr(cod),';')
            ic2=ic+codlt-1
            if(def(ic:min(defl,ic2)).eq.codstr(cod)(1:codlt))then
               ic=ic2
               linelt=linelt+1
               line(linelt:linelt)=codchr(cod:cod)
               goto 200
            endif
 250     continue
      endif
c     just copy the character to the decoded string
      linelt=linelt+1
      line(linelt:linelt)=chr
      goto 200
 290  continue

c     save
      savlin=line(1:linelt)
      savllt=linelt

c     default help
      call out2('Hit [Return] to leave unchanged, or enter '//
     & 'a solitary question mark for help.')

c     get the input
      goto 400
 390  call out('** Must write < as &lt; and > as &gt; unless '//
     & 'they are HTML tag terminators.')
 400  line=savlin
      call in2(line,linelt)

c     if the default is unchanged, return 0
      if(line(1:linelt).eq.savlin(prompl+3:savllt))then
         subl=0
         return
      endif

c     if blank, return blank
      if(linelt.eq.1 .and. line(1:1).eq.' ')then
         subl=1
         sub(1:1)=' '
         return
      endif

c     return requests for help
      if(linelt.eq.1 .and.line(1:1).eq.'?')then
         subl=1
         sub(1:1)='?'
         return
      endif

c     encode the input into sub
      tag=0
      link=0
      subl=0
      ic=0
c     next character from the input string
 500  ic=ic+1
      if(ic.gt.linelt)goto 590
      chr=line(ic:ic)
      cod=index(codchr,chr)
      if(cod.gt.0)goto 520
c     put the character in the encoded string as is
 510  subl=subl+1
      if(subl.gt.subd)call out('*** Encoded string is too long!')
      sub(subl:subl)=chr
      if(chr.eq.'G')goto 600
      if(chr.eq.'K')goto 700
      goto 500
c     must decide whether an & is already an encoded sequence or not
 520  if(chr.eq.'&')then
         if(tag.ne.0)goto 510
         ic2=index(line(ic:linelt),';')
         if(ic2.le.2)goto 530
         ic2=ic2+ic-1
         if(index(line(ic+1:ic2),'&').gt.0)goto 530
         if(index(line(ic+1:ic2),' ').gt.0)goto 530
         if(index(line(ic+1:ic2),char(9)).gt.0)goto 530
         goto 510
c     any < must open a tag
      else if(chr.eq.'<')then
         if(tag.ne.0)goto 390
         tag=1
         goto 510
c     any > must close a tag
      else if(chr.eq.'>')then
         if(tag.ne.1)goto 390
         tag=0
         goto 510
c     quotes inside tags should be preserved
      else if(chr.eq.'"')then
         if(tag.ne.0)goto 510
      endif
c     encode the character
 530  codlt=index(codstr(cod),';')
      if(subl+codlt.gt.subd)call out('*** Encoded string is too long!')
      sub(subl+1:subl+codlt)=codstr(cod)
      subl=subl+codlt
      goto 500
 590  goto 900

c     add image (do not change ic or line)
 600  if(line(max(1,ic-5):ic).ne.'PUTIMG')goto 500
      if(tag.ne.0)goto 390

c     give general info
      call out2(' ')
      if(subdir.ne.0)goto 615
      call out2('Enter the URL of the image *very* carefully, '//
     & 'watching for typos.  The wiz')
      call out2('cannot check the validity of the URL; '//
     & 'whatever you enter here goes.  An image')
      call out2('called "logo.jpg" put in a subfolder '//
     & '"images" of the index.tex folder has URL')
      call out2('"images/logo.jpg".  (The file extension '//
     & 'should be "jpg" or "gif", normally,')
      call out2('and cannot be left out.  Do not enter '//
     & 'the quotes.)  An image "seal.gif" put in')
      call out2('the same folder as index.tex has URL '//
     & '"seal.gif".  Enter the URL all the way')
      call out2('from "http://..." if you are unsure. '//
     & 'Enter a lone question mark for any')
      call out2('additional available info.  URLs are '//
     & 'CASE SENSITIVE.')
      goto 621
 615  call out2('Enter the URL of the image *very* carefully, '//
     &'watching for typos.  The wiz')
      call out2('cannot check the validity of the URL; '//
     & 'whatever you enter here goes.  Remember')
      call out2('that the web pages go in a subfolder.  '//
     & 'So, an image called "logo.jpg" put in a')
      call out2('subfolder "images" of the index.tex '//
     & 'folder has URL "../images/logo.jpg".  (The')
      call out2('file extension should be "jpg" or "gif", '//
     & 'normally, and cannot be left out.  Do')
      call out2('not enter the quotes.)  An image "seal.gif" '//
     & 'put in the same folder with')
      call out2('index.tex has URL "../seal.gif".  Enter '//
     & 'the URL all the way from "http://..."')
      call out2('if you are unsure.  Enter a lone question '//
     & 'mark for any additional available')
      call out2('info.  URLs are case sensitive.  DO '//
     & 'NOT CALL YOUR IMAGE INDEX.GIF.')

      goto 621

c     additional help
 620  call out2(' ')
      call out2('If the line length is not long enough '//
     &'to enter the entire URL, (don''t you')
      call out2('love them), enter as much as you can and edit '//
     & 'defaults.sub very carefully to')
      call out2('put in the rest.  Then rerun the wiz to apply.')

c     get the URL
 621  line2='URL:'
      call in2(line2,line2l)
      if(line2(1:line2l).eq.'?')goto 620
      if(line2(1:line2l).eq.' ')goto 400
      if(index(line2(1:line2l),'"').gt.0)then
         call out('** Double quotes are not supported.  '//
     &    'Enter a URL without them.')
         goto 621
      endif
      subl=subl-6+21
      if(subl.gt.subd)call out('*** Encoded string is too long!')
      sub(subl-20:subl)='<img border="0" src="'
      ic2=0
 650  ic2=ic2+1
      if(ic2.gt.line2l)goto 660
      subl=subl+1
      if(subl.gt.subd)call out('*** Encoded string is too long!')
      sub(subl:subl)=line2(ic2:ic2)
      if(sub(subl:subl).eq.'~')then
         subl=subl+2
         if(subl.gt.subd)call out('*** Encoded string is too long!')
         sub(subl-2:subl)='%7E'
      endif
      goto 650
 660  subl=subl+2
      if(subl.gt.subd)call out('*** Encoded string is too long!')
      sub(subl-1:subl)='">'
      goto 500

c     start link or end link (do not change ic or line)
 700  if(line(max(1,ic-3):ic).eq.'BLNK')goto 710
      if(line(max(1,ic-3):ic).ne.'ELNK')goto 500
      if(tag.ne.0)goto 390

c     end link
      if(link.le.0)then
         call out('** ELNK does not close BLNK.  Try again.')
         goto 400
      endif
      link=0
      sub(subl-3:subl)='</a>'
      goto 500

c     start link
 710  if(tag.ne.0)goto 390
      if(link.gt.0)then
         call out('** End the previous link before starting a new one.')
         goto 400
      endif
      link=1

c     give general info
      call out2(' ')
      if(subdir.ne.0)goto 715
      call out2('Enter the URL of the link *very* carefully, '//
     & 'watching for typos.  The wiz')
      call out2('cannot check the validity of the URL; '//
     & 'whatever you enter here goes.  A link to')
      call out2('a web page "copyright.html" put in a '//
     & 'subfolder "legal" of the index.tex folder')
      call out2('has URL "legal/copyright.html".  (The '//
     & 'file extension should be "html" or')
      call out2('"htm", normally, and cannot be left '//
     & 'out.  Do not enter the quotes.)  A link to')
      call out2('"about_us.htm" in the same folder as '//
     & 'index.tex has URL "about_us.htm".  Enter')
      call out2('the URL all the way from "http://..." '//
     & 'if you are unsure.  To enter an e-mail')
      call out2('link to "me@univ.edu", use "mailto:me@univ.edu".  '//
     & 'Enter a question mark for')
      call out2('any additional available info.  URLs '//
     & 'are CASE SENSITIVE.')
      goto 721
 715  call out2('Enter the URL of the link *very* carefully, '//
     &'watching for typos.  The wiz')
      call out2('cannot check the validity of the URL; '//
     & 'whatever you enter here goes.  Remember')
      call out2('that the web pages go in a subfolder.  '//
     & 'So, a link to a web page')
      call out2('"copyright.html" put in a subfolder '//
     & '"legal" of the index.tex folder has URL')
      call out2('"../legal/copyright.html".  (The file '//
     & 'extension should be "html" or "htm",')
      call out2('normally, and cannot be left out.  Do '//
     & 'not enter the quotes, of course.)  A')
      call out2('link to "about_us.htm" in the same folder '//
     & 'as index.tex has URL')
      call out2('"../about_us.htm".  Enter the URL all '//
     & 'the way from "http://..." if you are')
      call out2('unsure.  To enter an e-mail link to "'//
     & 'me@univ.edu", use "mailto:me@univ.edu".')
      call out2('Enter a lone question mark for any additional '//
     & 'available info.  URLs are CASE')
      call out2('SENSITIVE.')
      goto 721

c     give additional info
 720  call out2(' ')
      call out2('If the line length is not long enough '//
     &'to enter the entire URL, (don''t you')
      call out2('love them), enter as much as you can and edit '//
     & 'defaults.sub very carefully to')
      call out2('put in the rest.  Then rerun the wiz to apply.')

c     get the URL
 721  line2='URL:'
      call in2(line2,line2l)
      if(line2(1:line2l).eq.'?')goto 720
      if(line2(1:line2l).eq.' ')goto 400
      if(index(line2(1:line2l),'"').gt.0)then
         call out('** Double quotes are not supported.  '//
     &    'Enter a URL without them.')
         goto 721
      endif
      subl=subl-4+8+classl
      if(subl.gt.subd)call out('*** Encoded string is too long!')
      sub(subl-7-classl:subl)='<a'//class//'href="'
      ic2=0
 750  ic2=ic2+1
      if(ic2.gt.line2l)goto 760
      subl=subl+1
      if(subl.gt.subd)call out('*** Encoded string is too long!')
      sub(subl:subl)=line2(ic2:ic2)
      if(sub(subl:subl).eq.'~')then
         subl=subl+2
         if(subl.gt.subd)call out('*** Encoded string is too long!')
         sub(subl-2:subl)='%7E'
      endif
      goto 750
 760  subl=subl+2
      if(subl.gt.subd)call out('*** Encoded string is too long!')
      sub(subl-1:subl)='">'
      goto 500

 900  if(tag.gt.0)goto 390
      if(link.gt.0)then
         call out('** Hot link not terminated by ELNK.  Terminated '//
     &    'at end of text instead')
         subl=subl+4
         if(subl.gt.subd)call out('*** Encoded string is too long!')
         sub(subl-3:subl)='</a>'
      endif

      return
      end
