      subroutine askurl(subdir,prmpln,def,url,urll)

c     Asks for a URL.  If the user left the default, urll will return as
c     zero.  If the user entered a blank line, and the default is not
c     blank, urll will be 1 and url(1:1) blank.

c     avoid typos
      implicit none

c input

c     nonzero for web pages in a subdirectory
      integer subdir

c     prompt line
      character*(*) prmpln

c     default (if the default is empty, use a single space here.)
      character*(*) def

c output

c     url
      character*(80) url

c     length of the url, zero for unchanged
      integer urll

c local

c     length of the default
      integer defl

c     input line
      character*80 asklin

c executable

c     set the length of the default
      defl=len(def)

c     create the prompt line
      asklin='url:?'//def(1:min(defl,74))
      if(defl.gt.74)asklin(77:79)='...'

c     give general info, subdir=0
      if(subdir.ne.0)goto 50
      call out2('Enter the URL of the link *very* carefully, '//
     & 'watching for typos.  The wiz')
      call out2('cannot check the validity of the URL; '//
     & 'whatever you enter here goes.  A link to')
      call out2('a web page "doclist.html" put in a folder '//
     & 'immediately above the index.tex')
      call out2('folder has URL "../doclist.html".  (The '//
     & 'file extension should be "html" or')
      call out2('"htm", normally, and cannot be left '//
     & 'out.  Do not enter the quotes.)  A link to')
      call out2('"select.html" in the same folder as '//
     & 'index.tex has URL "select.html".  Enter')
      call out2('the URL all the way from "http://..." '//
     & 'if you are unsure.  Enter a question')
      call out2('mark for any additional available info.  '//
     & 'URLs are CASE SENSITIVE.')
      goto 110

c     give general info, subdir=1
 50   call out2('Enter the URL of the link *very* carefully, '//
     &'watching for typos.  The wiz')
      call out2('cannot check the validity of the URL; '//
     & 'whatever you enter here goes.  Remember')
      call out2('that the web pages go in a subfolder.  '//
     & 'So, a link to a web page')
      call out2('"doclist.html" put in a folder immediately '//
     & 'above the index.tex folder has URL')
      call out2('"../../doclist.html".  (The file extension '//
     & 'should be "html" or "htm",')
      call out2('normally, and cannot be left out.  Do '//
     & 'not enter the quotes.)  A link to')
      call out2('"index.html" in the same folder as index.tex '//
     & 'has URL "../index.html".  Enter')
      call out2('the URL all the way from "http://..." '//
     & 'if you are unsure.  Enter a lone')
      call out2('question mark for any additional available '//
     & 'info.  URLs are CASE SENSITIVE.')
      goto 110

c     give additional info
 100  call out2(' ')
      call out2('If the line length is not long enough '//
     &'to enter the entire URL, (don''t you')
      call out2('love them), enter as much as you can '//
     & 'and edit .latex2html-init very carefully')
      call out2('to put in the rest.  Then rerun the '//
     & 'wiz to apply.')

c     get the URL
 110  call out2(' ')
      call out2(prmpln)
      url=asklin
      call in2(url,urll)
      if(url(1:urll).eq.asklin(6:80))then
         urll=0
         return
      endif
      if(url(1:urll).eq.'?')goto 100
      if(url(1:1).eq.'"')then
         call out2('** Please leave out the surrounding quotes.')
         goto 110
      endif
      if(index(url(1:urll),'''').gt.0)then
         call out('** Url specifications with single quotes '//
     &    'are not supported.   Try using double')
         call out2('quotes or rename the link.')
         goto 110
      endif

      return
      end
