      subroutine getval(tag,att,
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,val,vall)

c     Finds a HTML tag attribute value in the index.css buffer and
c     returns it as a character string.

c     If the tag does not exist, returns fndct=-1.  If the tag exists,
c     but the attribute does not, returns fndct=0.

c     avoid typos
      implicit none

c input

c     tag to find
      character*(*) tag

c     attribute of that tag to find
      character*(*) att

c input/output

c     declared primary and secondary file buffer sizes
      integer bufdim
c     actual file buffer sizes
      integer bufmax,bufmx2
c     buffers
      character*1 bufstr(bufdim),bufst2(bufdim)

c     whether the original is in bufst2
      integer use2

c output

c     number of occurrences of the attribute
      integer fndct
c     value
      character*(*) val
      integer vall

c local

c     size of value
      integer vald

c     white space
      character*4 white

c     index
      integer i
c     limits of the value
      integer i1,i2

c     temporaries
      integer itemp,itemp2

c executable:

c     white space
      white=' '//char(9)//char(10)//char(13)

c     initialize value length
      vall=0

c     select the attribute
      call selatt(tag,att,
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,itemp)
      if(fndct.le.0)goto 900

c     select the value from : to closing semicolon or bracket
      call trnit(
     & ':\\?\\~\\&;}\\*\\&;}\\*','\\s1',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,itemp)
      if(fndct.lt.1)call fatal('getval: Program error')

c     value string size
      vald=len(val)

c     ensure the selection is in bufstr to simplify things
      call set1(bufdim,bufmax,bufstr,bufmx2,bufst2,use2)

c     find the limits of the value without leading and trailing whitespace
      do 110 i=bufmax-1,1,-1
         i2=i
         if(index(white,bufstr(i)).le.0)goto 111
 110  continue
 111  continue
      i1=2
      do 120 i=2,i2
         i1=i
         if(index(white,bufstr(i)).le.0)goto 121
 120  continue
 121  continue

c     read the value
      do 150 i=i1,i2
         vall=vall+1
         if(vall.gt.vald)call fatal('getval: Value too big')
         val(vall:vall)=bufstr(i)
 150  continue

c     deselect all
 900  call trnit(
     & '\\d',' ',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,itemp,itemp2)

c     all done
      return
      end
