      subroutine seltag(tag,
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct)

c     Selects a HTML tag from the index.css buffer, from the ^J to the
c     closing curly bracket.

c     avoid typos
      implicit none

c input

c     tag to find
      character*(*) tag

c input/output

c     declared primary and secondary file buffer sizes
      integer bufdim
c     actual file buffer sizes
      integer bufmax,bufmx2
c     buffers
      character*1 bufstr(bufdim),bufst2(bufdim)

c     whether the original is in bufst2
      integer use2

c output

c     number of occurrences of the tag
      integer fndct

c local

c     local copy of the tag, to keep g77 happy
      character*80 ltag
      integer ltagl

c     temporary
      integer itemp

c executable:

c     copy the tag to local
      ltagl=len(tag)
      if(ltagl.le.0)call fatal('seltag: Missing tag')
      if(ltagl.gt.80)call fatal('seltag: Tag too long')
      ltag(1:ltagl)=tag

c     select the tag
      call trnit(
     & '\\-\\J\\?\\_'//ltag(1:ltagl)//'\\?\\+{\\?\\~\\&{}\\*}','\\s',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,itemp)

c     warn for multiple instances
      if(fndct.gt.1)then
         call type('duptag')
         call out2('      '//ltag(1:ltagl))
         call typep('restidx')
      endif

c     all done
      return
      end
