      subroutine subcol(rblue,rblack,rwhite,chicon)

c     Creates l2hcolsb.sub that changes the name of the background color.
c
c     If chicon is nonzero, also creates substitution file l2hcols.sub
c     that changes the colors of pnm files of the latex2html-fu iconsblu
c     into other colors, and iconloc.sub that changes ICONLOC into
c     rblue//rwhite.

c     avoid typos
      implicit none

c input

c     hex format replacements for the colors
      character*6 rblue,rblack,rwhite

c     zero if we want to keep the existing icons
      integer chicon

c local

c     used characters (in GR)
      integer used(0:255)

c     complete color table
      character*36 tabh
      character*18 tabc

c     hex characters
      character*16 hex
      parameter (hex='0123456789ABCDEF')

c     initial substitutions for the colors
      character*9 inis

c     final substitutions
      character*6 fnl
      integer fnll

c     indices
      integer i,i2

c executable

c     set the color table
      tabh='0033AA000000FFFFFF'//rblue//rblack//rwhite
      do 10 i=1,18
         tabc(i:i)=char((index(hex,tabh(2*i-1:2*i-1))-1)*16
     &    +index(hex,tabh(2*i:2*i))-1)
 10   continue

c     zero the used characters
      do 20 i=160,255
         used(i)=0
 20   continue
      do 30 i=1,18
         used(ichar(tabc(i:i)))=1
 30   continue

c     make safe substitutions
      i2=159
      do 50 i=1,9
 40      i2=i2+1
         if(used(i2).ne.0)goto 40
         inis(i:i)=char(i2)
 50   continue

c     create l2hcols.sub

      if(chicon.eq.0)goto 300

c     initial substitutions
      call opennw(2,'l2hcols.sub')
      write(2,110,err=900)tabc(1:3)
      write(2,110,err=900)inis(1:3)
      write(2,110,err=900)tabc(4:6)
      write(2,110,err=900)inis(4:6)
      write(2,110,err=900)tabc(7:9)
      write(2,110,err=900)inis(7:9)
 110  format(a)

c     final substitutions
      do 200 i=1,3
         fnll=0
         do 150 i2=1,3
            fnll=fnll+1
            fnl(fnll:fnll)='\\'
            fnll=fnll+1
            if(tabc(9+(i-1)*3+i2:9+(i-1)*3+i2).eq.char(10))then
               fnl(fnll:fnll)='J'
            else if(tabc(9+(i-1)*3+i2:9+(i-1)*3+i2).eq.char(13))then
               fnl(fnll:fnll)='M'
            else if(tabc(9+(i-1)*3+i2:9+(i-1)*3+i2).eq.'\\')then
               fnl(fnll:fnll)='\\'
            else
               fnll=fnll-1
               fnl(fnll:fnll)=tabc(9+(i-1)*3+i2:9+(i-1)*3+i2)
            endif
 150     continue
         write(2,110,err=900)inis(i*3-2:i*3)
         write(2,110,err=900)fnl(1:fnll)
 200  continue
      close(2,err=900)

c     create l2hcolsb.sub

c     write the file
 300  call opennw(2,'l2hcolsb.sub')
      write(2,110,err=900)'FFFFFF'
      write(2,110,err=900)tabh(31:36)
      close(2,err=900)

c     create iconloc.sub

      if(chicon.eq.0)goto 800

c     write the file
      call opennw(2,'iconloc.sub')
      write(2,110,err=900)'ICONLOC'
      write(2,110,err=900)tabh(19:24)//tabh(31:36)
      close(2,err=900)

 800  return
 900  call fatal('subcol: Cannot create file l2hcols.sub')
 910  call fatal('subcol: Cannot create file l2hcols2.sub')
      end
