      subroutine trnit(
     & str1,str2,
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)

c     Translates str1 into str2.  If use2=0, bufstr is used as the
c     buffer to translate and bufst2 is the result; if use2=1, it is the
c     other way around.

c     avoid typos
      implicit none

c input:

c     strings to put in the buffer
      character*(*) str1
      character*(*) str2

c input/output

c     declared primary and secondary file buffer sizes
      integer bufdim
c     actual file buffer sizes
      integer bufmax,bufmx2
c     buffers
      character*1 bufstr(bufdim),bufst2(bufdim)

c     whether the original is in bufst2
      integer use2

c output:

c     counter of matches found
      integer fndct
c     counter of nontrivial substitutions done
      integer subct

c local

c     declared original string size
      integer orgdim
      parameter (orgdim=10000)
c     actual original string size
      integer orgmax
c     original string
      character*1 orgstr(orgdim)
c     modifiers
      character*1 orgmod(orgdim)
      save orgmax,orgstr,orgmod

c     declared translation string size
      integer trndim
      parameter (trndim=orgdim)
c     actual translation string size
      integer trnmax
c     translation string
      character*1 trnstr(trndim)
      save trnmax,trnstr

c     declared memory string size
      integer memdim
      parameter (memdim=orgdim)
c     actual memory size
      integer memmax
c     memory string
      character*1 memstr(memdim)
      save memstr,memmax

c executable:

c     put the strings in the internal I/O buffer
      call setbuf(str1,str2)

c     do the translation
      call dopair(
     & 0,0,0,'sys_fil',
     & orgdim,orgmax,orgstr,orgmod,trndim,trnmax,trnstr,
     & memdim,memmax,memstr,
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,
     & fndct,subct,
     & *910,*920)

c     done
      return

c     error
 910  call fatal('Should be no end of file on internal unit')
 920  call fatal('Reopen command not supported for internal unit')
      end
