      program wizhlp

c     Helper for the wizard utility.  Does things DOS simply won't do.

c     Usage: wizhlp path task [relevant parameters]
c     where path is the path to the wiz files.

c     Compile this file with the Gnu Fortran compiler using the makefile

c declarations

c     avoid typos
      implicit none

c common path to the wiz files

c     path string
      character*132 path
c     actual path string length
      integer pathl
      common /cmpath/pathl,path

c common data from dopair

c     declared substring selection levels
      integer levdim
      parameter (levdim=1000)
c     actual substring selection level
      integer lev
c     available bufdim at each level
      integer bufdml(0:levdim)
c     start of the post-selection string
      integer post(levdim)
c     after a successfull \f#, the #-th occurrence is from fnddat(2) to (3)
      integer fnddat(3)
c     total substitutions
      integer subtot
c     total found strings
      integer fndtot
c     total missed substitutions
      integer subnot
c     total missed searches
      integer fndnot
c     previous value of subtot at \x command
      integer oldsct

      common/cmpair/lev,bufdml,post,
     & fnddat,
     & subtot,fndtot,subnot,fndnot,oldsct

c local

c     command line arguments
      integer argdim
      parameter (argdim=9)
      integer argmx
      character*132 argt(argdim)
      integer argtl(argdim)
      external args

c     number of style sheet tags that are editable
      integer ssemax
      parameter (ssemax=38)
c     editable style sheet tag index
      integer sse
c     declared editable style sheet tag name length
      integer ssetgd
      parameter (ssetgd=18)
c     actual editable style sheet tag name length
      integer ssetgl
c     editable style sheet tag names
      character*(ssetgd) ssetag(ssemax)
      data ssetag/
     & 'BODY',
     & 'H1','H2','H3','H4','H5','H6',
     & 'CAPTION',
     & 'TT','code','pre',
     & 'SMALL.XTINY','SMALL.TINY','SMALL.SCRIPTSIZE',
     & 'SMALL.FOOTNOTESIZE','SMALL.SMALL','BIG.LARGE',
     & 'BIG.XLARGE','BIG.XXLARGE','BIG.HUGE','BIG.XHUGE',
     & 'HR',
     & 'TD','TD.eqno','TD.runner','TD.runnerb',
     & 'a:link','a:visited','a:active','a:hover',
     & 'a.runner:link','a.runner:visited',
     & 'a.runner:active','a.runner:hover',
     & 'a.runnerb:link','a.runnerb:visited',
     & 'a.runnerb:active','a.runnerb:hover'/
c     declared editable style sheet description name length
      integer ssedsd
      parameter (ssedsd=28)
c     editable style sheet tag descriptions
      character*(ssedsd) ssedsc(ssemax)
      data ssedsc/
     & 'body (normal)',
     & 'H1 (part title)','H2 (chapter title)',
     & 'H3 (section title)','H4 (subsection title)',
     & 'H5 (subsubsection title)','H6 (paragraph title)',
     & 'caption',
     & 'tt (typewriter)','code (verb)','pre (verbatim)',
     & 'extra tiny','tiny','scriptsize',
     & 'footnotesize','small','large',
     & 'Large','LARGE','huge','Huge',
     & 'HTML ruler',
     & 'TD','TD.eqno','top bar','bottom bar',
     & 'unvisited link','visited link','active link','link under mouse',
     & 'unvisited link, top bar','visited link, top bar',
     & 'active link, top bar','link under mouse, top bar',
     & 'unvisited link, bottom bar','visited link, bottom bar',
     & 'active link, bottom bar','link under mouse, bottom bar'/
c     font size magscales, powers of 1.2 (cheat for numbers 9-11)
      integer ssemag(ssemax)
      data ssemag/
     & 0,
     & 5,4,3,2,1,0,
     & 0,
     & 1,1,1,
     & -5,-4,-3,-2,-1,1,2,3,4,5,
     & 99,
     & 0,0,0,0,
     & 99,99,99,99,
     & 99,99,99,99,
     & 99,99,99,99/
c     color codes (blwh is black/white, depending on background)
      integer cwhite,cblack,ctitle,cblue,cblueb,cblwh
      parameter (cwhite=1,cblack=2,ctitle=3,cblue=4,cblueb=5,cblwh=6)
c     foreground color classifications
      integer ssecol(ssemax)
      data ssecol/
     & cblack,
     & ctitle,ctitle,ctitle,ctitle,ctitle,ctitle,
     & cblack,
     & cblack,cblack,cblack,
     & 0,0,0,0,0,0,0,0,0,0,
     & cblue,
     & cblack,cblack,cblwh,cblwh,
     & cblack,cblack,ctitle,ctitle,
     & cblwh,cblwh,cblwh,cblwh,
     & cblwh,cblwh,cblwh,cblwh/
c     background color classifications
      integer ssebcl(ssemax)
      data ssebcl/
     & cwhite,
     & 0,0,0,0,0,0,
     & 0,
     & 0,0,0,
     & 0,0,0,0,0,0,0,0,0,0,
     & cblue,
     & 0,0,cblue,cblueb,
     & 0,0,0,0,
     & -cblue,-cblue,-cblue,-cblue,
     & -cblueb,-cblueb,-cblueb,-cblueb/
c     selectors
      integer ssemrk(ssemax)

c     number of navigation icons we are worried about
      integer navmax
      parameter (navmax=15)
c     navigation icon index
      integer nav
c     navigation icon names in iconsizes, plus a space
      character*20 navnam(navmax)
      data navnam/'up','next','previous','next_group','next_inactive',
     & 'previous_group','change_begin','change_begin_right',
     & 'change_end','change_end_right','change_delete',
     & 'change_delete_right','contents','index','image'/
c     navigation icon name length
      integer navnml
c     corresponding navigation icon file names, plus a space
      character*9 navfil(navmax)
      data navfil/'up','next','prev','nx_grp','next_g',
     & 'pv_grp','ch_begin','ch_beg_r',
     & 'ch_end','ch_end_r','ch_delet',
     & 'ch_del_r','contents','index','image'/
c     navigation file length
      integer navfll
c     picture size
      integer xsiz,ysiz
c     folder length
      character*80 icfol
      integer icfoll
c     icon size string
      character*800 icons
      integer iconsl

c     declared primary and secondary file buffer sizes
      integer bufdim
      parameter (bufdim=250000)
c     actual file buffer sizes
      integer bufmax,bufmx2,bufmx3,bufmx4,bufmx5,bufmx0
c     buffer index
      integer buf
c     file buffers
      character*1 bufstr(bufdim),bufst2(bufdim)
      character*1 bufst3(bufdim),bufst4(bufdim)
      character*1 bufst5(bufdim),bufst0(bufdim)
      character*(bufdim) bufln5
      equivalence (bufst5(1),bufln5(1:1))

c     counter of matches found
      integer fndct
c     counter of nontrivial substitutions done
      integer subct

c     whether we use buffer 0,2,3,4
      integer use0,use2,use3,use4

c     whether we must write new files
      integer wrtidx,wrtl2h
      data wrtidx/0/,wrtl2h/0/

c     font size from the body tag
      integer fntsz0
c     entered body font size (float)
      real fntszb
c     font size
      integer fntsiz
      real fntszr
c     scale factor
      real scale

c     document body font size (float)
      real fntszd

c     default colors, from index.css
      character*6 dwhite,dblack,dtitle,dblue,dblueb
c     replacement colors
      character*6 rwhite,rblack,rtitle,rblue,rblueb,rblwh
c     whether we want to change icons
      integer chicon
c     color distance
      integer coldis
      external coldis

c     count of failures
      integer failct

c     nonzero if we have a DOS file
      integer crlf

c     hex characters
      character*16 hex
      parameter (hex='0123456789ABCDEF')

c     declared number of original/translation pairs
      integer otdim
      parameter (otdim=20)
c     actual number of original/translation pairs
      integer otmax
c     original/translation pair index
      integer ot
c     declared original string length
      integer orgdim
      parameter (orgdim=80)
c     actual original string length
      integer orgmax(otdim)
c     originals
      character*(orgdim) org(otdim)
c     declared translation string length
      integer trndim
      parameter (trndim=2048)
c     actual translation string length
      integer trnmax(otdim)
c     translations
      character*(trndim) trn(otdim)
c     whether the string is available for changing
      integer avail(otdim)
c     new translation string length
      integer trnnwl
c     new translation
      character*(trndim) trnnw

c     nonzero if the web pages are put in a subdirectory
      integer subdir

c     nonzero if we have a link
      integer havlnk

c     generic lines
      character*80 line,line2
      integer linelt,line2l

c     answer
      character*1 ans

c     bracket nesting level
      integer depth

c     line count
      integer linect

c     current quote character
      character*1 quot

c     number as character string
      character*20 cnum
      integer cnuml

c     whether a file exists
      logical exists

c     iteration index
      integer iter

c     character
      character*1 chr,prvchr

c     generic index
      integer i

c     temporaries
      integer itemp,itemp2
      real temp

c executable

c     generic character format
 10   format(a,a,a)

c     allow I/O to use units 7 and on
      call libini(7)

c     set the error exit status to 9 to allow some passing of pointers
      call errset(9)

c     get the command line arguments
      call args(argdim,'Usage: wizhlp path task [relevant parameters]',
     & argmx,argt,argtl)
      if(argmx.lt.2)goto 9990

c     set path to wiz files
      path=argt(1)
      pathl=argtl(1)

c     Process the functions

      if(argt(2)(1:argtl(2)).ne.'fntsiz')goto 1200

c *****************************************************************************
c     fntsiz: change font size
c *****************************************************************************

c     read the style file to change into storage
      call readfu('index.css',9,2,bufdim,bufmax,bufstr)
      use2=0

c     convert crlf into lf
      call trnit('\\M\\J','\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,crlf)
      call trnit('\\M\\J','\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,itemp)

c     remove the combined style font attributes stupid me left in
      do 1110 i=1,100
         call trnit('{font: \\?\\5px , Arial, Verdana, Georgia, '//
     &    'Geneva, sans-serif;}','\\s1',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         if(fndct.lt.0)goto 1111
         call trnit('{font:','{\\J'//char(9)//char(9)//'   font-size:',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         call trnit(
     &    'px ,','px;\\J'//char(9)//char(9)//'   font-family:',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         call trnit(
     &    ';}','\\J'//char(9)//char(9)//'   }',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         call trnit('\\d',' ',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
 1110 continue
 1111 call trnit('\\d',' ',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)

c     find body font size
      call getval('BODY','font-size',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,line,linelt)
      fntsz0=0
      if(fndct.eq.-1)then
         call typep('nobody')
      else if(linelt.le.0)then
         call warn('index.css is corrupt: no body font size specified')
      else
         do 1130 i=1,linelt
            if(line(i:i).lt.'0' .or. line(i:i).gt.'9')then
               if(line(i:linelt).eq.'px')goto 1132
               goto 1131
            endif
            fntsz0=fntsz0*10+ichar(line(i:i))-48
 1130    continue
 1131    fntsz0=0
         call warn('body font size corrupt in index.css')
 1132    continue
      endif

c     ask for the new size
      call type('askbfsz')
 1140 if(fntsz0.eq.0)fntsz0=15
      fntsz0=max(10,min(30,fntsz0))
      call encint(fntsz0,cnuml,cnum)
      line='Enter new normal font size: '//cnum(1:cnuml)
      call in(line)
      call readvl(line,fntszb,*1140)
      if(fntszb.lt.9.6)then
         call out('** Think again.')
         goto 1140
      endif
      if(fntszb.lt.9.6 .or. fntszb.gt.40.4)then
         call out('** Accepted range is 10 to 40')
         goto 1140
      endif

c     convert all tags with font sizes
      failct=0
      do 1150 sse=1,ssemax
         ssemrk(sse)=0
         if(ssemag(sse).eq.99)goto 1150
         fntsiz=nint(fntszb*1.2**ssemag(sse))
         if(sse.ge.9 .and. sse.le.11)fntsiz=nint(fntszb*1.07)
         fntsiz=max(7,min(99,fntsiz))
         call encint(fntsiz,cnuml,cnum)
         ssetgl=index(ssetag(sse),' ')-1
         if(ssetgl.le.0)ssetgl=ssetgd
         call setval(ssetag(sse)(1:ssetgl),'font-size',
     &    cnum(1:cnuml)//'px',0,
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         if(fndct.le.0)ssemrk(sse)=1
         if(fndct.le.0)failct=failct+1
         if(subct.gt.0)wrtidx=1
 1150 continue

c     warn about failures
      if(failct.gt.0)then
         call type('badfsiz')
         call lsttag(ssemax,ssedsc,ssemrk)
         call pause
      endif

c     convert lf into crlf
      if(crlf.ne.0)call trnit('\\J','\\M\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)

c     write the new index.css file
      if(wrtidx.ne.0)then
         if(use2.eq.0)then
            call writfu('index.new',9,2,bufdim,bufmax,bufstr)
         else
            call writfu('index.new',9,2,bufdim,bufmx2,bufst2)
         endif
      endif

c     change .latex2html-init

c     read the file to change into storage
      call readfu('.latex2html-init',16,2,bufdim,bufmax,bufstr)
      use2=0

c     ask for document font size
      call type('askdfsiz')
 1160 line='Enter document font size in points: 10'
      call in(line)
      call readvl(line,fntszd,*1160)
      if(fntszd.lt.6.6)then
         call out('** Think again.')
         goto 1160
      endif
      if(fntszd.lt.6.6 .or. fntszd.gt.15.4)then
         call out('** Accepted range is 7 to 15')
         goto 1160
      endif

c     compute new scale factor
      scale=fntszb*0.1185*10./fntszd
      write(cnum(1:6),1170)scale
 1170 format(f6.3)
      i=1
      if(cnum(1:1).eq.' ')i=2

c     replace the scale factor
      call trnit(
     & '$MATH_SCALE_FACTOR\\?\\+=\\?\\+\\?\\&\\5.\\*\\?\\+;',
     & '$MATH_SCALE_FACTOR = '//cnum(i:6)//';',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,wrtl2h)
      if(fndct.le.0)then
         call warn(
     &    'Unable to change the math images size in .latex2html-init')
         call typep('restl2hi')
      endif

c     ask for display magnification
      call type('askdmag')
 1180 line='Enter the magnification factor for displayed formulae: 1'
      call in(line)
      call readvl(line,scale,*1180)
      if(scale.lt.0.5 .or. scale.gt.2.)then
         call out('** Accepted range is 0.5 to 2')
         goto 1180
      endif

c     replace the magnification factor
      write(cnum(1:6),1170)scale
      i=1
      if(cnum(1:1).eq.' ')i=2
      call trnit(
     & '$DISP_SCALE_FACTOR\\?\\+=\\?\\+\\?\\&\\5.\\*\\?\\+;',
     & '$DISP_SCALE_FACTOR = '//cnum(i:6)//';',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      wrtl2h=wrtl2h+subct
      if(fndct.le.0)then
         call warn('Unable to change the display scale factor '//
     &    'in .latex2html-init')
         call typep('restl2hi')
      endif

c     ask for figure magnification
      call type('askfmag')
 1190 line='Enter the magnification factor for figures: 1.6'
      call in(line)
      call readvl(line,scale,*1190)
      if(scale.lt.0.25 .or. scale.gt.4.)then
         call out('** Accepted range is 0.25 to 4')
         goto 1190
      endif

c     replace the magnification factor
      write(cnum(1:6),1170)scale
      i=1
      if(cnum(1:1).eq.' ')i=2
      call trnit(
     & '$FIGURE_SCALE_FACTOR\\?\\+=\\?\\+\\?\\&\\5.\\*\\?\\+;',
     & '$FIGURE_SCALE_FACTOR = '//cnum(i:6)//';',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      wrtl2h=wrtl2h+subct
      if(fndct.le.0)then
         call warn('Unable to change the figure scale factor '//
     &    'in .latex2html-init')
         call typep('restl2hi')
      endif

c     write the new .latex2html-init file
      if(wrtl2h.ne.0)then
         if(use2.eq.0)then
            call writfu('new.latex2html-init',19,2,bufdim,bufmax,bufstr)
         else
            call writfu('new.latex2html-init',19,2,bufdim,bufmx2,bufst2)
         endif
      endif

c     done
      goto 9900

 1200 if(argt(2)(1:argtl(2)).ne.'colors')goto 1400

c *****************************************************************************
c     colors: change color scheme
c *****************************************************************************

c     read the style file to change into storage
      call readfu('index.css',9,2,bufdim,bufmax,bufstr)
      use2=0

c     convert crlf into lf
      call trnit('\\M\\J','\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,crlf)
      call trnit('\\M\\J','\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,itemp)

c     get the background color from index.css and ask for the replacement
 1310 call getval('BODY','background-color',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,line,linelt)
      dwhite='FFFFFF'
      if(fndct.eq.-1)then
         call typep('nobody')
      else if(linelt.le.0)then
         call warn(
     &    'No background color specified in index.css; frames version?')
      else if(linelt.eq.7)then
         if(line(1:1).ne.'#')goto 1312
         do 1311 i=2,7
            if(line(i:i).ge.'a' .and. line(i:i).le.'z')
     &       line(i:i)=char(ichar(line(i:i))-32)
            if(index(hex,line(i:i)).le.0)goto 1312
 1311    continue
         dwhite=line(2:7)
 1312    continue
      endif
      call askcol('Enter the new background color',dwhite,rwhite)
      dwhite=rwhite

c     get the text color from index.css and ask for the replacement
      call getval('BODY','color',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,line,linelt)
      dblack='000000'
      if(fndct.eq.-1)then
      else if(linelt.le.0)then
         call warn(
     &    'No text color specified in index.css; frames version?')
      else if(linelt.eq.7)then
         if(line(1:1).ne.'#')goto 1322
         do 1321 i=2,7
            if(line(i:i).ge.'a' .and. line(i:i).le.'z')
     &       line(i:i)=char(ichar(line(i:i))-32)
            if(index(hex,line(i:i)).le.0)goto 1322
 1321    continue
         dblack=line(2:7)
 1322    continue
      endif
      call askcol('Enter the new normal text color',dblack,rblack)
      dblack=rblack
      if(coldis(rwhite,rblack).lt.150)then
         call out('** Text and background are hard to distinguish.')
         line='Are you sure about those colors? [y/n]:'
         call inkey(5,'yn',line,ans)
         if(ans.ne.'y')goto 1310
      endif

c     get the title color from index.css and ask for the replacement
      call getval('H3','color',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,line,linelt)
      dtitle='000066'
      if(linelt.eq.7)then
         if(line(1:1).ne.'#')goto 1332
         do 1331 i=2,7
            if(line(i:i).ge.'a' .and. line(i:i).le.'z')
     &       line(i:i)=char(ichar(line(i:i))-32)
            if(index(hex,line(i:i)).le.0)goto 1332
 1331    continue
         dtitle=line(2:7)
 1332    continue
      endif
      call askcol('Enter the color for section titles',dtitle,rtitle)
      dtitle=rtitle

c     get the top bar color from index.css and ask for the replacement
 1340 call getval('TD.runner','background-color',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,line,linelt)
      dblue='0033AA'
      if(linelt.eq.7)then
         if(line(1:1).ne.'#')goto 1342
         do 1341 i=2,7
            if(line(i:i).ge.'a' .and. line(i:i).le.'z')
     &       line(i:i)=char(ichar(line(i:i))-32)
            if(index(hex,line(i:i)).le.0)goto 1342
 1341    continue
         dblue=line(2:7)
 1342    continue
      endif
      call askcol('Enter the new color of the top bar',dblue,rblue)
      dblue=rblue

c     get the bottom bar color from index.css and ask for the replacement
 1345 call getval('TD.runnerb','background-color',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,line,linelt)
      dblueb='0033AA'
      if(linelt.eq.7)then
         if(line(1:1).ne.'#')goto 1347
         do 1346 i=2,7
            if(line(i:i).ge.'a' .and. line(i:i).le.'z')
     &       line(i:i)=char(ichar(line(i:i))-32)
            if(index(hex,line(i:i)).le.0)goto 1347
 1346    continue
         dblueb=line(2:7)
 1347    continue
      endif
      call askcol('Enter the new color of the bottom bar',dblueb,rblueb)
      dblueb=rblueb

c     set the colors
      failct=0
      do 1350 sse=1,ssemax
         ssemrk(sse)=0
         ssetgl=index(ssetag(sse),' ')-1
         if(ssetgl.le.0)ssetgl=ssetgd
         if(ssecol(sse).eq.cwhite)then
            call setval(ssetag(sse)(1:ssetgl),'color',
     &       '#'//rwhite,0,
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
            if(fndct.le.0)ssemrk(sse)=1
            if(fndct.le.0)failct=failct+1
            if(subct.gt.0)wrtidx=1
         endif
         if(ssebcl(sse).eq.cwhite)then
            call setval(ssetag(sse)(1:ssetgl),'background-color',
     &       '#'//rwhite,0,
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
            if(fndct.le.0)ssemrk(sse)=1
            if(fndct.le.0)failct=failct+1
            if(subct.gt.0)wrtidx=1
         endif
         if(ssecol(sse).eq.cblack)then
            call setval(ssetag(sse)(1:ssetgl),'color',
     &       '#'//rblack,0,
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
            if(fndct.le.0)ssemrk(sse)=1
            if(fndct.le.0)failct=failct+1
            if(subct.gt.0)wrtidx=1
         endif
         if(ssebcl(sse).eq.cblack)then
            call setval(ssetag(sse)(1:ssetgl),'background-color',
     &       '#'//rblack,0,
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
            if(fndct.le.0)ssemrk(sse)=1
            if(fndct.le.0)failct=failct+1
            if(subct.gt.0)wrtidx=1
         endif
         if(ssecol(sse).eq.ctitle)then
            call setval(ssetag(sse)(1:ssetgl),'color',
     &       '#'//rtitle,0,
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
            if(fndct.le.0)ssemrk(sse)=1
            if(fndct.le.0)failct=failct+1
            if(subct.gt.0)wrtidx=1
         endif
         if(ssebcl(sse).eq.ctitle)then
            call setval(ssetag(sse)(1:ssetgl),'background-color',
     &       '#'//rtitle,0,
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
            if(fndct.le.0)ssemrk(sse)=1
            if(fndct.le.0)failct=failct+1
            if(subct.gt.0)wrtidx=1
         endif
         if(ssecol(sse).eq.cblue)then
            call setval(ssetag(sse)(1:ssetgl),'color',
     &       '#'//rblue,0,
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
            if(fndct.le.0)ssemrk(sse)=1
            if(fndct.le.0)failct=failct+1
            if(subct.gt.0)wrtidx=1
         endif
         if(ssebcl(sse).eq.cblue)then
            call setval(ssetag(sse)(1:ssetgl),'background-color',
     &       '#'//rblue,0,
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
            if(fndct.le.0)ssemrk(sse)=1
            if(fndct.le.0)failct=failct+1
            if(subct.gt.0)wrtidx=1
         endif
         if(ssecol(sse).eq.cblueb)then
            call setval(ssetag(sse)(1:ssetgl),'color',
     &       '#'//rblueb,0,
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
            if(fndct.le.0)ssemrk(sse)=1
            if(fndct.le.0)failct=failct+1
            if(subct.gt.0)wrtidx=1
         endif
         if(ssebcl(sse).eq.cblueb)then
            call setval(ssetag(sse)(1:ssetgl),'background-color',
     &       '#'//rblueb,0,
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
            if(fndct.le.0)ssemrk(sse)=1
            if(fndct.le.0)failct=failct+1
            if(subct.gt.0)wrtidx=1
         endif
         if(ssecol(sse).eq.cblwh)then
            rblwh=rblack
            i=abs(ssebcl(sse))
            if(i.eq.cblack)then
               rblwh=rwhite
            else if(i.eq.cblue)then
               if(coldis(rwhite,rblue).gt.coldis(rblack,rblue))
     &          rblwh=rwhite
            else if(i.eq.cblueb)then
               if(coldis(rwhite,rblueb).gt.coldis(rblack,rblueb))
     &          rblwh=rwhite
            else if(i.eq.ctitle)then
               if(coldis(rwhite,rtitle).gt.coldis(rblack,rtitle))
     &          rblwh=rwhite
            endif 
            call setval(ssetag(sse)(1:ssetgl),'color',
     &       '#'//rblwh,0,
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
            if(fndct.le.0)ssemrk(sse)=1
            if(fndct.le.0)failct=failct+1
            if(subct.gt.0)wrtidx=1
         endif
 1350 continue

c     warn about failures
      if(failct.gt.0)then
         call type('badcols')
         call lsttag(ssemax,ssedsc,ssemrk)
         call pause
      endif

c     convert lf into crlf
      if(crlf.ne.0)call trnit('\\J','\\M\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)

c     write the new index.css file
      if(wrtidx.ne.0)then
         if(use2.eq.0)then
            call writfu('index.new',9,2,bufdim,bufmax,bufstr)
         else
            call writfu('index.new',9,2,bufdim,bufmx2,bufst2)
         endif
      endif

c     ask whether we want to change the navigation icons
      call type('navicons')
      line='Do you want to create new navigation icons? [y/n]: y'
      call inkey(5,'yn',line,ans)
      chicon=1
      if(ans.ne.'y')chicon=0

c     change .latex2html-init

c     read the file to change into storage
      call readfu('.latex2html-init',16,2,bufdim,bufmax,bufstr)
      use2=0

c     replace the alternative icons strings
      if(chicon.ne.0)then
      call trnit('$ALTERNATIVE_ICONS\\?\\+=\\-\\?\\+"C:\\\\\\\\'//
     & 'l2hsup\\\\\\\\\\?\\~""','$ALTERNATIVE_ICONS = "C:\\\\\\\\'//
     & 'l2hsup\\\\\\\\'//rblue//rwhite//'"',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      wrtl2h=wrtl2h+subct
      if(fndct.le.0)then
         call out(' ')
         call out('** Warning: Unable to change the DOS icon '//
     &    'location in .latex2html-init')
         call typep('restl2hi')
      endif
      call trnit(
     & '$ALTERNATIVE_ICONS\\?\\+=\\?\\+"$ENV{L2HTOP}/l2hsup/\\?\\~""',
     & '$ALTERNATIVE_ICONS = "$ENV{L2HTOP}/l2hsup/'//rblue//rwhite//'"',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      wrtl2h=wrtl2h+subct
      if(fndct.le.0)then
         call warn(
     &    'Unable to change the Unix icon location in .latex2html-init')
         call typep('restl2hi')
      endif
      endif

c     change the background color
      if(rwhite.eq.'FFFFFF')then
         call trnit(
     &    '$WHITE_BACKGROUND\\?\\+=\\?\\~;;',
     &    '$WHITE_BACKGROUND = 1;',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         wrtl2h=wrtl2h+subct
         call trnit(
     &    '$LATEX_COLOR\\?\\+=\\?\\~;;',
     &    '$LATEX_COLOR = "\\\\\\\\pagecolor[rgb]{1,1,1}";',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         wrtl2h=wrtl2h+subct
      else
         call trnit(
     &    '$WHITE_BACKGROUND\\?\\+=\\?\\~;;',
     &    '$WHITE_BACKGROUND = '''';',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         wrtl2h=wrtl2h+subct
         line=' '
         write(line(1:17),1370)
     &    ((index(hex,rwhite(1:1))-1)*16+index(hex,rwhite(2:2))-1)/255.,
     &    ((index(hex,rwhite(3:3))-1)*16+index(hex,rwhite(4:4))-1)/255.,
     &    ((index(hex,rwhite(5:5))-1)*16+index(hex,rwhite(6:6))-1)/255.
 1370    format(f5.3,',',f5.3,',',f5.3)
         call trnit(
     &    '$LATEX_COLOR\\?\\+=\\?\\~;;',
     &    '$LATEX_COLOR = "\\\\\\\\pagecolor[rgb]{'//line(1:17)//'}";',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         wrtl2h=wrtl2h+subct
      endif

c     write the new .latex2html-init file
      if(wrtl2h.ne.0)then
         if(use2.eq.0)then
            call writfu('new.latex2html-init',19,2,bufdim,bufmax,bufstr)
         else
            call writfu('new.latex2html-init',19,2,bufdim,bufmx2,bufst2)
         endif
      endif

c     create the color substitution files
      call subcol(rblue,rblack,rwhite,chicon)

c     done
      goto 9900

 1400 if(argt(2)(1:argtl(2)).ne.'setatt')goto 1600

c *****************************************************************************
c     setatt: set individual style sheet attributes
c *****************************************************************************

c     read the style file to change into storage
      call readfu('index.css',9,2,bufdim,bufmax,bufstr)
      use2=0

c     convert crlf into lf
      call trnit('\\M\\J','\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,crlf)
      call trnit('\\M\\J','\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,itemp)

c     remove the combined style font attributes stupid me left in
      do 1505 i=1,100
         call trnit('{font: \\?\\5px , Arial, Verdana, Georgia, '//
     &    'Geneva, sans-serif;}','\\s1',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         if(fndct.lt.0)goto 1506
         call trnit('{font:','{\\J'//char(9)//char(9)//'   font-size:',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         call trnit(
     &    'px ,','px;\\J'//char(9)//char(9)//'   font-family:',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         call trnit(
     &    ';}','\\J'//char(9)//char(9)//'   }',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         call trnit('\\d',' ',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
 1505 continue
 1506 call trnit('\\d',' ',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)

c     get the tag to change
 1510 do 1520 sse=1,ssemax
         ssemrk(sse)=1
 1520 continue
      call type('seltag')
      call lsttgn(ssemax,ssedsc,ssemrk)
      call out(' ')
      goto 1531
 1530 call out('** Invalid tag number')
 1531 line='Enter tag number: 0'
      call in2(line,linelt)
      if(linelt.lt.1 .or. linelt.gt.3)goto 1530
      call readvl(line(1:linelt),temp,*1530)
      sse=nint(temp)
      if(sse.eq.0)goto 1590
      if(sse.le.0 .or. sse.gt.ssemax)goto 1530
      ssetgl=index(ssetag(sse),' ')-1
      if(ssetgl.le.0)ssetgl=ssetgd

c     get attributes
 1540 call getval(ssetag(sse)(1:ssetgl),'font-size',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,line,linelt)
      if(fndct.lt.0)then
         call out('** tag was not found in index.css')
         goto 1531
      endif
      call out(' ')
      call out('Select an attribute to change:')
      if(fndct.le.0)then
         call out('   1) font-size: [not available]')
      else
         if(linelt.gt.0)call out('   1) font-size: '//line(1:linelt))
         if(linelt.le.0)call out('   1) font-size:')
      endif
      call getval(ssetag(sse)(1:ssetgl),'color',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,line,linelt)
      if(fndct.lt.0)call out('** wizhlp: Program error; lost tag!')
      if(fndct.le.0)then
         call out('   2) color: [not available]')
      else
         if(linelt.gt.0)call out('   2) color: '//line(1:linelt))
         if(linelt.le.0)call out('   2) color:')
      endif
      call getval(ssetag(sse)(1:ssetgl),'background-color',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,line,linelt)
      if(fndct.lt.0)call out('** wizhlp: Program error; lost tag!')
      if(fndct.le.0)then
         call out('   3) background-color: [not available]')
      else
         if(linelt.gt.0)call out('   3) background-color: '//
     &    line(1:linelt))
         if(linelt.le.0)call out('   3) background-color:')
      endif
      line='Select the attribute to change: 0'
      call inkey(5,'0123',line,ans)
      if(ans.eq.'0')goto 1510
      if(ans.eq.'1')then
         call getval(ssetag(sse)(1:ssetgl),'font-size',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,line,linelt)
         cnum(1:1)=' '
         cnuml=1
         if(linelt.gt.0)then
            i=max(index(line(1:linelt),'px'),index(line(1:linelt),'PX'))
            if(i.gt.1)then
               cnuml=i-1
               cnum(1:cnuml)=line(1:cnuml)
            endif
         endif
         if(fndct.le.0)then
            line='Create the tag?  Are you sure? [y/n]: n'
            call inkey(5,'yn',line,ans)
            if(ans.ne.'y')goto 1540
         endif
         call type('askfsiz')
         goto 1551
 1550    call out('** invalid number of pixels')
 1551    line='Enter the number of pixels: '//cnum(1:cnuml)
         call in2(line,linelt)
         if(line(1:linelt).eq.cnum(1:cnuml))goto 1540
         call readvl(line(1:linelt),fntszr,*1550)
         fntsiz=nint(fntszr)
         if(fntsiz.lt.2 .or. fntsiz.gt.99)goto 1550
         call encint(fntsiz,cnuml,cnum)
         call setval(ssetag(sse)(1:ssetgl),'font-size',
     &    cnum(1:cnuml)//'px',1,
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         wrtidx=wrtidx+subct
         goto 1540
      else if(ans.eq.'2')then
         call getval(ssetag(sse)(1:ssetgl),'color',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,line,linelt)
         dblack=' '
         if(linelt.eq.7)then
            if(line(1:1).ne.'#')goto 1562
            do 1561 i=2,7
               if(line(i:i).ge.'a' .and. line(i:i).le.'z')
     &          line(i:i)=char(ichar(line(i:i))-32)
               if(index(hex,line(i:i)).le.0)goto 1562
 1561       continue
            dblack=line(2:7)
 1562       continue
         endif
         if(fndct.le.0)then
            line='Create the tag?  Are you sure? [y/n]: n'
            call inkey(5,'yn',line,ans)
            if(ans.ne.'y')goto 1540
         endif
         call askcol('Enter the new color',dblack,rblack)
         if(rblack.eq.dblack)goto 1540
         call setval(ssetag(sse)(1:ssetgl),'color',
     &    '#'//rblack,1,
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         wrtidx=wrtidx+subct
         goto 1540
      else if(ans.eq.'3')then
         call getval(ssetag(sse)(1:ssetgl),'background-color',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,line,linelt)
         dblack=' '
         if(linelt.eq.7)then
            if(line(1:1).ne.'#')goto 1572
            do 1571 i=2,7
               if(line(i:i).ge.'a' .and. line(i:i).le.'z')
     &          line(i:i)=char(ichar(line(i:i))-32)
               if(index(hex,line(i:i)).le.0)goto 1572
 1571       continue
            dblack=line(2:7)
 1572       continue
         endif
         if(fndct.le.0)then
            line='Create the tag?  Are you sure? [y/n]: n'
            call inkey(5,'yn',line,ans)
            if(ans.ne.'y')goto 1540
         endif
         call askcol('Enter the new background color',dblack,rblack)
         if(rblack.eq.dblack)goto 1540
         call setval(ssetag(sse)(1:ssetgl),'background-color',
     &    '#'//rblack,1,
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         wrtidx=wrtidx+subct
         goto 1540
      else
         call out('** wizhlp: Program error in inkey')
      endif

c     convert lf into crlf
 1590 if(crlf.ne.0)call trnit('\\J','\\M\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)

c     write the new index.css file
      if(wrtidx.ne.0)then
         if(use2.eq.0)then
            call writfu('index.new',9,2,bufdim,bufmax,bufstr)
         else
            call writfu('index.new',9,2,bufdim,bufmx2,bufst2)
         endif
      endif

      goto 9900

 1600 if(argt(2)(1:argtl(2)).ne.'myicons')goto 1800

c *****************************************************************************
c     myicons: swap in my own icon set
c *****************************************************************************

c     change .latex2html-init

c     get the location of the icons
 1709 call type('askmyic')
 1710 icfol='Please enter the name of the folder with the icons:'
      call in2(icfol,icfoll)
      if(icfol(1:icfoll).eq.' ')goto 9900
      if(index(icfol(1:icfoll),'?').ne.0)goto 1709

c     check for appropriateness
      do 1720 i=1,icfoll
         chr=icfol(i:i)
         if(chr.ge.'0' .and. chr.le.'9')goto 1720
         if(chr.ge.'a' .and. chr.le.'z')goto 1720
         if(chr.ge.'A' .and. chr.le.'Z')goto 1720
         if(chr.eq.'_')goto 1720
         if(chr.eq.'-' .and. i.gt.1)goto 1720
         call out2('** invalid character "'//chr//'" in folder name')
         goto 1710
 1720 continue

c     read the file to change into storage
      call readfu('.latex2html-init',16,2,bufdim,bufmax,bufstr)
      use2=0
      if(bufstr(bufmax).eq.char(26))call warn('** ^Z')

c     convert crlf into lf
      call trnit('\\M\\J','\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,crlf)
      call trnit('\\M\\J','\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,itemp)

c     create the new iconsizes
      icons='%iconsizes = (\\J'
      iconsl=16
      do 1750 nav=1,navmax
         navfll=index(navfil(nav),' ')-1
         navnml=index(navnam(nav),' ')-1
         call gifsz(2,path(1:pathl-4)//icfol(1:icfoll)//
     &    path(pathl:pathl)//navfil(nav)(1:navfll)//'.gif',
     &    xsiz,ysiz)
         if(xsiz.le.-3)then
            call out('** Required navigation icon not found:')
            call out2('   '//path(1:pathl-4)//icfol(1:icfoll)//
     &       path(pathl:pathl)//navfil(nav)(1:navfll)//'.gif')
            goto 1710
         endif
         if(xsiz.le.-2)then
            call out('** Navigation icon is locked:')
            call out2('   '//path(1:pathl-4)//icfol(1:icfoll)//
     &       path(pathl:pathl)//navfil(nav)(1:navfll)//'.gif')
            goto 1710
         endif
         if(xsiz.le.0 .or. ysiz.le.0)then
            call out('** Unable to read picture dimensions of:')
            call out2('   '//path(1:pathl-4)//icfol(1:icfoll)//
     &       path(pathl:pathl)//navfil(nav)(1:navfll)//'.gif')
            goto 1710
         endif
         icons(iconsl+1:iconsl+8+navnml+10)=char(9)//'      '''//
     &    navnam(nav)(1:navnml)//''',''WIDTH="'
         i=iconsl+8
         iconsl=iconsl+8+navnml+10
         call encint(xsiz,cnuml,cnum)
         icons(iconsl+1:iconsl+cnuml+10)=cnum(1:cnuml)//'" HEIGHT="'
         iconsl=iconsl+cnuml+10
         call encint(ysiz,cnuml,cnum)
         if(navnam(nav)(max(1,navnml-4):navnml).eq.'right')then
            icons(iconsl+1:iconsl+cnuml+19)=cnum(1:cnuml)//
     &       '" ALIGN="RIGHT"'',\\J'
            iconsl=iconsl+cnuml+19
         else
            icons(iconsl+1:iconsl+cnuml+5)=cnum(1:cnuml)//'"'',\\J'
            iconsl=iconsl+cnuml+5
         endif
         call out2(icons(i:iconsl-2))
 1750 continue
      iconsl=iconsl-3
      icons(iconsl+1:iconsl+10)='\\J'//char(9)//'      )'
      iconsl=iconsl+10

c     convert the string
      call trnit(
     & '%iconsizes\\?\\+=\\?\\+(\\?\\~\\&()\\*)',icons(1:iconsl),
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,wrtl2h)
      if(fndct.le.0)then
         call warn('Warning: Unable to change the navigation icon '//
     &    'sizes in .latex2html-init')
         call typep('restl2hi')
      endif

c     set the alternative icons
      call trnit('$ALTERNATIVE_ICONS\\?\\+=\\-\\?\\+"C:\\\\\\\\'//
     & 'l2hsup\\\\\\\\\\?\\~""','$ALTERNATIVE_ICONS = "C:\\\\\\\\'//
     & 'l2hsup\\\\\\\\'//icfol(1:icfoll)//'"',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      wrtl2h=wrtl2h+subct
      if(fndct.le.0)then
         call out(' ')
         call out('** Warning: Unable to change the DOS icon '//
     &    'location in .latex2html-init')
         call typep('restl2hi')
      endif
      call trnit(
     & '$ALTERNATIVE_ICONS\\?\\+=\\?\\+"$ENV{L2HTOP}/l2hsup/\\?\\~""',
     & '$ALTERNATIVE_ICONS = "$ENV{L2HTOP}/l2hsup/'//
     & icfol(1:icfoll)//'"',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      wrtl2h=wrtl2h+subct
      if(fndct.le.0)then
         call warn('Warning: Unable to change the Unix icon '//
     &    'location in .latex2html-init')
         call typep('restl2hi')
      endif

c     convert lf into crlf
      if(crlf.ne.0)call trnit('\\J','\\M\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)

c     write the new .latex2html-init file
      if(wrtl2h.ne.0)then
         if(use2.eq.0)then
            call writfu('new.latex2html-init',19,2,bufdim,bufmax,bufstr)
         else
            call writfu('new.latex2html-init',19,2,bufdim,bufmx2,bufst2)
         endif
      endif

c     create iconloc.sub
      call opennw(2,'iconloc.sub')
      write(2,10,err=9910)'ICONLOC'
      write(2,10,err=9910)icfol(1:icfoll)
      close(2,err=9910)

      goto 9900


 1800 if(argt(2)(1:argtl(2)).ne.'headers')goto 2000

c *****************************************************************************
c     headers: edit headers
c *****************************************************************************

c     read the originals and translations

c     open the originals/translations file
      call openru('defaults.sub',1)
c     initialize line count
      linect=1
c     initialize the pair index
      ot=1
c     next pair
 1810 orgmax(ot)=0
      trnmax(ot)=0
      i=0
c     read next character of original
 1820 call getchr(1,chr,*1850,*9950)
      if(chr.eq.char(13))goto 1820
      if(chr.eq.char(10))then
         linect=linect+1
         if(orgmax(ot).le.0)goto 1820
         goto 1830
      endif
      i=i+1
      if(i.gt.orgdim)then
         call encint(linect,cnuml,cnum)
         call out('*** original too long in defaults.sub, line '//
     &    cnum(1:cnuml)//'!')
      endif
      org(ot)(i:i)=chr
      if(chr.gt.' ')orgmax(ot)=i
      goto 1820
 1830 i=0
c     read next character of translation
 1840 call getchr(1,chr,*1850,*9950)
      if(chr.eq.char(13))goto 1840
      if(chr.eq.char(10))then
         linect=linect+1
         ot=ot+1
         if(ot.gt.otdim)
     &    call out('*** wizhlp: too many items in defaults.sub!')
         goto 1810
      endif
      i=i+1
      if(i.gt.trndim)then
         call encint(linect,cnuml,cnum)
         call out('*** translation too long in defaults.sub, line '//
     &    cnum(1:cnuml)//'!')
      endif
      trn(ot)(i:i)=chr
      if(chr.gt.' ')trnmax(ot)=i
      goto 1840
c     end
 1850 if(orgmax(ot).le.0)ot=ot-1
      otmax=ot
      if(otmax.lt.1)call out('*** wizhlp: file defaults.sub is empty!')
c     close file
      close(1,err=9950)

c     read the template file into storage
      inquire(file='template.html',exist=exists,err=9910)
      if(exists)then
         call readfu('template.html',13,2,bufdim,bufmax,bufstr)
      else
         call readfu(path(1:pathl-4)//'files'//path(pathl:pathl)//
     &    'template.html',pathl+15,2,bufdim,bufmax,bufstr)
      endif
      use2=0

c     convert crlf into lf
      call trnit('\\M\\J','\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,itemp)
      call trnit('\\M\\J','\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,itemp)

c     select trailing bar area

c     select all from the end of the text area
      call trnit(
     & 'less\\?\\+you\\?\\+are\\?\\+good\\?\\+in\\?\\+Perl.)]\\?\\~\\]',
     & '\\s1',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0)call out('*** wizhelp: '//
     & 'template.html has a corrupted end of the text block!')
c     remove the end of the text area
      call trnit(
     & 'less\\?\\+you\\?\\+are\\?\\+good\\?\\+in\\?\\+Perl.)]',
     & '\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
c     remove from </body> onwards
      call trnit(
     & '\\-</BODY>\\?\\~\\]',
     & '\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0)call out('*** wizhelp: '//
     & 'template.html is corrupted: no </body> tag!')
c     remove the navigation div
      call trnit(
     & '\\-<DIV\\?\\+CLASS="navigation">',
     & '\\s1',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      bufmax=0
      bufmx2=0
      call trnit('\\d1',' ',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,itemp,itemp2)
      if(fndct.le.0)then
         call warn(
     &    'corrupt template.html: no bottom navigation div (ignored).')
      else
         call trnit(
     &    '\\-</DIV>\\?\\+<!--\\?\\+End\\?\\+of\\?\\+Navigation'//
     &    '\\?\\+Panel\\?\\+-->\\?\\+','\\s',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         bufmax=0
         bufmx2=0
         call trnit('\\d1',' ',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,itemp,itemp2)
         if(fndct.le.0)then
            call warn('wizhelp: uncertain bottom navigation DIV end '//
     &       'in template.html')
            call trnit('\\-</DIV>','\\s',
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
            if(fndct.le.0)
     &       call out('*** Make that: cannot find the end at all!')
            bufmax=0
            bufmx2=0
            call trnit('\\d1',' ',
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         endif
      endif
c     remove leading whitespace
      call trnit('\\?\\+','\\s1',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      bufmax=0
      bufmx2=0
      call trnit('\\d1',' ',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,itemp,itemp2)
c     remove trailing whitespace
      call trnit('\\?\\+\\]','\\s',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      bufmax=0
      bufmx2=0
      call trnit('\\d1',' ',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,itemp,itemp2)
c     protect against interpolation
      call trnit('\\\\','\\\\\\\\',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      call trnit('@','\\\\@',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      call trnit('$','\\\\$',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      call trnit('"','\\\\"',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
c     clear up line breaks
      call trnit('\\J','\\\\n" .\\J    "',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
c     copy to bufst4
      if(use2.eq.0)then
         call copy(bufdim,bufmax,bufstr,bufdim,bufmx4,bufst4)
      else
         call copy(bufdim,bufmx2,bufst2,bufdim,bufmx4,bufst4)
      endif
c     deselect all
      call trnit('\\d',' ',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,itemp,itemp2)

c     select leading bar area

c     select all from the body tag
      call trnit('\\-<body\\~\\l\\?\\~\\]','\\s1',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0 .or. fndct.gt.1)call out('*** wizhelp: '//
     & 'corrupt template.html: missing or multiple BODY tag!')
c     remove the body tag
      call trnit('\\-<body\\?\\~\\&<>\\*>','\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0)call out('*** wizhelp: '//
     & 'corrupt template.html: missing BODY tag!')
c     remove from the start of the text block onwards
      call trnit(
     & '\\-[<i>Do\\?\\+not\\?\\+touch\\?\\+this\\?\\+text,\\?\\~\\]',
     & '\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0)call out('*** wizhelp: '//
     & 'corrupt template.html: invalid start of text area!')
c     remove the navigation div
      call trnit(
     & '\\-<DIV\\?\\+CLASS="navigation">',
     & '\\s1',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      bufmax=0
      bufmx2=0
      call trnit('\\d1',' ',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,itemp,itemp2)
      if(fndct.le.0)then
         call warn(
     &    'corrupt template.html: no top navigation div (ignored).')
      else
         call trnit(
     &    '\\-</DIV>\\?\\+<!--\\?\\+End\\?\\+of\\?\\+Navigation'//
     &    '\\?\\+Panel\\?\\+-->\\?\\+','\\s',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         bufmax=0
         bufmx2=0
         call trnit('\\d1',' ',
     &    bufdim,bufmax,bufstr,bufmx2,bufst2,use2,itemp,itemp2)
         if(fndct.le.0)then
            call warn('wizhelp: uncertain top navigation DIV end '//
     &       'in template.html')
            call trnit('\\-</DIV>','\\s',
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
            if(fndct.le.0)
     &       call out('*** Make that: cannot find the end at all!')
            bufmax=0
            bufmx2=0
            call trnit('\\d1',' ',
     &       bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
         endif
      endif
c     remove leading whitespace
      call trnit('\\?\\+','\\s1',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      bufmax=0
      bufmx2=0
      call trnit('\\d1',' ',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,itemp,itemp2)
c     remove trailing whitespace
      call trnit('\\?\\+\\]','\\s',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      bufmax=0
      bufmx2=0
      call trnit('\\d1',' ',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,itemp,itemp2)
c     protect against interpolation
      call trnit('\\\\','\\\\\\\\',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      call trnit('@','\\\\@',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      call trnit('$','\\\\$',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      call trnit('"','\\\\"',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
c     clear up line breaks
      call trnit('\\J','\\\\n" .\\J    "',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
c     copy to bufst3
      if(use2.eq.0)then
         call copy(bufdim,bufmax,bufstr,bufdim,bufmx3,bufst3)
      else
         call copy(bufdim,bufmx2,bufst2,bufdim,bufmx3,bufst3)
      endif
c     deselect all
      call trnit('\\d',' ',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,itemp,itemp2)

c     see which tags are missing
      do 1860 ot=1,otmax
         use2=0
         call trnit(org(ot)(1:orgmax(ot)),'\\f1',
     &    bufdim,bufmx3,bufst3,bufmx2,bufst2,use2,fndct,subct)
         use2=0
         call trnit(org(ot)(1:orgmax(ot)),'\\f1',
     &    bufdim,bufmx4,bufst4,bufmx2,bufst2,use2,itemp,subct)
         fndct=fndct+itemp
         avail(ot)=fndct
 1860 continue

c     read the .latex2html-init file into memory

c     read the file into storage
      call readfu('.latex2html-init',16,2,bufdim,bufmax,bufstr)
      use2=0

c     convert crlf into lf
      call trnit('\\M\\J','\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,crlf)
      call trnit('\\M\\J','\\J',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,itemp)

c     find the value of subdir
      call trnit('$NO_SUBDIR\\?\\+=\\?\\&\\+\\5\\''\\*;','\\s',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $NO_SUBDIR is not defined!')
      if(fndct.gt.1)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $NO_SUBDIR multiply defined!')
      subdir=0
      call trnit('$NO_SUBDIR\\?\\+=\\?\\+1\\?\\+;','\\f',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      call trnit('$NO_SUBDIR\\?\\+=\\?\\+0\\?\\+;','\\f',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,subdir,subct)
      if(fndct+subdir.ne.1)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $NO_SUBDIR is not set to either 0 or 1!')
      call trnit('\\d',' ',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)

c     find and clear sub bot_navigation_panel {

c     select all from the subroutine name onwards
      call trnit(
     & '\\J\\?\\+sub\\?\\+bot_navigation_panel\\?\\+{\\?\\~\\]','\\s',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: cannot find bot_navigation_panel!')
c     set to be in bufstr
      call set1(bufdim,bufmax,bufstr,bufmx2,bufst2,use2)
c     zero everything logically between the curly brackets
      depth=0
      quot=' '
      chr=' '
      do 1880 buf=1,bufmax
         prvchr=chr
         chr=bufstr(buf)
         if(quot.eq.' ')then
            if(chr.eq.'{')then
               depth=depth+1
            else if(chr.eq.'}')then
               depth=depth-1
               if(depth.le.0)goto 1885
            else if(chr.eq.'"')then
               quot='"'
            else if(chr.eq.'''')then
               quot=''''
            endif
         else
            if(chr.eq.quot .and. prvchr.ne.'\\')then
               quot=' '
            endif
         endif
         if(depth.gt.0)bufstr(buf)=char(0)
 1880 continue
      call out('*** wizhlp: .latex2html-init is corrupt: no end to '//
     & 'bot_navigation panel!')
 1885 continue
c     deselect
      call trnit('\\d',' ',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)

c     find and clear sub top_navigation_panel {

c     select all from the subroutine name onwards
      call trnit(
     & '\\J\\?\\+sub\\?\\+top_navigation_panel\\?\\+{\\?\\~\\]','\\s',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: cannot find top_navigation_panel!')
c     set to be in bufstr
      call set1(bufdim,bufmax,bufstr,bufmx2,bufst2,use2)
c     zero everything logically between the curly brackets
      depth=0
      quot=' '
      chr=' '
      do 1890 buf=1,bufmax
         prvchr=chr
         chr=bufstr(buf)
         if(quot.eq.' ')then
            if(chr.eq.'{')then
               depth=depth+1
            else if(chr.eq.'}')then
               depth=depth-1
               if(depth.le.0)goto 1895
            else if(chr.eq.'"')then
               quot='"'
            else if(chr.eq.'''')then
               quot=''''
            endif
         else
            if(chr.eq.quot .and. prvchr.ne.'\\')then
               quot=' '
            endif
         endif
         if(depth.gt.0)bufstr(buf)=char(0)
 1890 continue
      call out('*** wizhlp: .latex2html-init is corrupt: no end to '//
     & 'top_navigation panel!')
 1895 continue
c     deselect
      call trnit('\\d',' ',
     & bufdim,bufmax,bufstr,bufmx2,bufst2,use2,fndct,subct)

c     copy to bufmx0 for safekeeping
      if(use2.eq.0)then
         call copy(bufdim,bufmax,bufstr,bufdim,bufmx0,bufst0)
      else
         call copy(bufdim,bufmx2,bufst2,bufdim,bufmx0,bufst0)
      endif
      use0=1

c     write menu
 1900 do 1910 ot=1,otmax
         line=' '
         line(2:2)=char(mod(ot,10)+48)
         if(ot.ge.10)line(1:1)=char(ot/10+48)
         linelt=3+orgmax(ot)
         if(linelt.le.79)then
            line(4:linelt)=org(ot)(1:orgmax(ot))
         else
            linelt=79
            line(4:79)=org(ot)(1:73)//'...'
         endif
         if(avail(ot).le.0)then
            if(linelt.gt.52)then
               linelt=52
               line(50:52)='...'
            endif
            line(53:79)=' [missing in template.html]'
         endif
         call out2(line(1:linelt))
         if(trnmax(ot).le.0)goto 1910
         line(1:3)='   '
         linelt=3+trnmax(ot)
         if(linelt.le.79)then
            line(4:linelt)=trn(ot)(1:trnmax(ot))
         else
            linelt=79
            line(4:79)=trn(ot)(1:73)//'...'
         endif
         call out2(line(1:linelt))
 1910 continue

c     ask for choice
      goto 1921
 1920 call out('*** Invalid number,try again')
 1921 line='Please enter the number of the item to change, '//
     & 'or 0 to finish: 0'
      call in2(line,linelt)
      call readvl(line(1:linelt),temp,*1920)
      if(index(line(1:linelt),'.').gt.0)goto 1920
      if(index(line(1:linelt),'-').gt.0)goto 1920
      ot=nint(temp)
      if(ot.lt.0 .or. ot.gt.otmax)goto 1920
      if(ot.eq.0)goto 1930
      call out2(' ')
      if(index(org(ot)(1:orgmax(ot)),'ROW_OF_BUTTONS').gt.0)then
 1924    call out2('Please enter the buttons for '//
     &    org(ot)(1:orgmax(ot))//':')
         call asksub(subdir,' ','Buttons',
     &    trn(ot)(1:trnmax(ot)),trnnw,trnnwl)
         if(trnnwl.eq.1 .and. trnnw(1:1).eq.'?')then
            call type('askbutns')
            goto 1924
         endif
      else
 1926    call out2(
     &    'Enter the text, (and/or images and links), for '//
     &    org(ot)(1:orgmax(ot))//':')
         if(index(org(ot)(1:orgmax(ot)),'Return_Link').gt.0)then
            call asksub(0,' ','BLNKtextELNK',
     &       trn(ot)(1:trnmax(ot)),trnnw,trnnwl)
         else if(index(org(ot)(1:orgmax(ot)),'Bottom').le.0)then
            call asksub(subdir,' class="runner" ','Text',
     &       trn(ot)(1:trnmax(ot)),trnnw,trnnwl)
         else
            call asksub(subdir,' class="runnerb" ','Text',
     &       trn(ot)(1:trnmax(ot)),trnnw,trnnwl)
         endif
         if(trnnwl.eq.1 .and. trnnw(1:1).eq.'?')then
            call type('asktext')
            goto 1926
         endif
      endif
      if(trnnwl.le.0)goto 1900
      if(trnnwl.eq.1 .and. trnnw(1:1).eq.' ')then
         trnmax(ot)=0
         goto 1900
      endif
      trnmax(ot)=trnnwl
      trn(ot)(1:trnnwl)=trnnw(1:trnnwl)
      goto 1900

c     apply the substitutions
 1930 use3=1
      use4=1
      do 1960 iter=1,2
         do 1959 ot=1,otmax
c           skip item if not present
            if(avail(ot).le.0)goto 1959
c           skip cleaning up if no translation
            bufmx5=0
            if(trnmax(ot).le.0)goto 1940
c           copy the translation into bufst5
            call copy(trndim,trnmax(ot),trn(ot),bufdim,bufmx5,bufst5)
            use2=0
c           protect characters against Perl interpolation, except $TITLE
            call trnit('\\\\','\\\\\\\\',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('$','\\\\$',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('\\\\$TITLE','$RUNNING_TITLE',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('@','\\\\@',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('"','\\\\"',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
c           encode the buttons
            call trnit('[NEXT]','$NEXT',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('[PREVIOUS]','$PREVIOUS',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('[UP]','$UP',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('[INDEX]','$INDEX',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('[CONTENTS]','$CONTENTS',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('[NEXT_GROUP]','$NEXT_GROUP',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('[PREVIOUS_GROUP]','$PREVIOUS_GROUP',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('[CUSTOM]','$CUSTOM_BUTTONS',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
c           encode the titles
            call trnit('Next_Title','\\\\n" .\\J    '//
     &       '($NEXT_TITLE ? " To: $NEXT_TITLE\\\\n" : "\\\\n") .'//
     &       '\\J    "',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('Previous_Title','\\\\n" .\\J    '//
     &       '($PREVIOUS_TITLE ? " To: $PREVIOUS_TITLE\\\\n" '//
     &       ': "\\\\n") .\\J    "',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('Up_Title','\\\\n" .\\J    '//
     &       '($UP_TITLE ? " Up to: $UP_TITLE\\\\n" : "\\\\n") .'//
     &       '\\J    "',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('Next_Group_Title','\\\\n" .\\J    '//
     &       '($NEXT_GROUP_TITLE ? " To: $NEXT_GROUP_TITLE\\\\n" '//
     &       ': "\\\\n") .\\J    "',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
            call trnit('Previous_Group_Title','\\\\n" .\\J    '//
     &       '($PREVIOUS_GROUP_TITLE ? " To: $PREVIOUS_GROUP_TITLE'//
     &       '\\\\n" : "\\\\n") .\\J    "',
     &       bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
c           set to be in bufst5
            call set1(bufdim,bufmx5,bufst5,bufmx2,bufst2,use2)
c           translate
 1940       if(iter.eq.1)then
 1942          call trnit(org(ot)(1:orgmax(ot)),'\\s1',
     &          bufdim,bufmax,bufstr,bufmx3,bufst3,use3,fndct,subct)
               call set1(bufdim,bufmax,bufstr,bufmx3,bufst3,use3)
               if(fndct.gt.0)then
                  if(bufmx5.gt.bufdml(lev))call out('*** wizhlp: '//
     &             'out of storage!')
                  do 1944 i=1,bufmx5
                     bufstr(i)=bufst5(i)
 1944             continue
                  bufmax=bufmx5
               endif
               call trnit('\\d',' ',
     &          bufdim,bufmax,bufstr,bufmx3,bufst3,use3,fndct,subct)
               if(fndct.gt.0)goto 1942
            else
 1946          call trnit(org(ot)(1:orgmax(ot)),'\\s1',
     &          bufdim,bufmax,bufstr,bufmx4,bufst4,use4,fndct,subct)
               call set1(bufdim,bufmax,bufstr,bufmx4,bufst4,use4)
               if(fndct.gt.0)then
                  if(bufmx5.gt.bufdml(lev))call out('*** wizhlp: '//
     &             'out of storage!')
                  do 1948 i=1,bufmx5
                     bufstr(i)=bufst5(i)
 1948             continue
                  bufmax=bufmx5
               endif
               call trnit('\\d',' ',
     &          bufdim,bufmax,bufstr,bufmx4,bufst4,use4,fndct,subct)
               if(fndct.gt.0)goto 1946
            endif
 1959    continue
         if(iter.eq.1)then
            call trnit('" .\\J    "" .\\J','" .\\J',
     &       bufdim,bufmax,bufstr,bufmx3,bufst3,use3,fndct,subct)
            call trnit('" .\\J    "\\]','\\ ',
     &       bufdim,bufmax,bufstr,bufmx3,bufst3,use3,fndct,subct)
            if(use3.eq.0)
     &       call copy(bufdim,bufmax,bufstr,bufdim,bufmx3,bufst3)
            if(bufmx3.le.0)call out('** no top page area!')
            if(bufst3(bufmx3).eq.char(0))bufmx3=bufmx3-1
         else
            call trnit('" .\\J    "" .\\J','" .\\J',
     &       bufdim,bufmax,bufstr,bufmx4,bufst4,use4,fndct,subct)
            call trnit('" .\\J    "\\]','\\ ',
     &       bufdim,bufmax,bufstr,bufmx4,bufst4,use4,fndct,subct)
            if(use4.eq.0)
     &       call copy(bufdim,bufmax,bufstr,bufdim,bufmx4,bufst4)
            if(bufmx4.le.0)call out('** no bottom page area!')
            if(bufst4(bufmx4).eq.char(0))bufmx4=bufmx4-1
         endif
 1960 continue

c     put in top_navigation_panel
      use2=1
      call trnit(
     & '\\J\\?\\+sub\\?\\+top_navigation_panel\\?\\+\\?\\ }','\\s',
     & bufdim,bufmax,bufstr,bufmx0,bufst0,use2,fndct,subct)
      if(fndct.ne.1)call out('*** wizhlp: .latex2html-init is corrupt!')
      call set1(bufdim,bufmax,bufstr,bufmx0,bufst0,use2)
      if(bufmx3+36+3.gt.bufdml(lev))
     & call out('*** wizhlp: out of storage!')
      line=char(10)//char(10)//'sub top_navigation_panel {'
     & //char(10)//'    "\\n'
      bufmax=0
      do 1970 i=1,36
         bufmax=bufmax+1
         bufstr(bufmax)=line(i:i)
 1970 continue
      do 1971 i=1,bufmx3
         bufmax=bufmax+1
         bufstr(bufmax)=bufst3(i)
 1971 continue
      bufmax=bufmax+1
      bufstr(bufmax)='"'
      bufmax=bufmax+1
      bufstr(bufmax)=char(10)
      bufmax=bufmax+1
      bufstr(bufmax)='}'
      call trnit('\\d',' ',
     & bufdim,bufmax,bufstr,bufmx0,bufst0,use2,fndct,subct)

c     put in bot_navigation_panel
      call trnit(
     & '\\J\\?\\+sub\\?\\+bot_navigation_panel\\?\\+\\?\\ }','\\s',
     & bufdim,bufmax,bufstr,bufmx0,bufst0,use2,fndct,subct)
      if(fndct.ne.1)call out('*** wizhlp: .latex2html-init is corrupt!')
      call set1(bufdim,bufmax,bufstr,bufmx0,bufst0,use2)
      if(bufmx4+36+3.gt.bufdml(lev))
     & call out('*** wizhlp: out of storage!')
      line=char(10)//char(10)//'sub bot_navigation_panel {'
     & //char(10)//'    "\\n'
      bufmax=0
      do 1980 i=1,36
         bufmax=bufmax+1
         bufstr(bufmax)=line(i:i)
 1980 continue
      do 1981 i=1,bufmx4
         bufmax=bufmax+1
         bufstr(bufmax)=bufst4(i)
 1981 continue
      bufmax=bufmax+1
      bufstr(bufmax)='"'
      bufmax=bufmax+1
      bufstr(bufmax)=char(10)
      bufmax=bufmax+1
      bufstr(bufmax)='}'
      call trnit('\\d',' ',
     & bufdim,bufmax,bufstr,bufmx0,bufst0,use2,fndct,subct)

c     convert lf into crlf
      if(crlf.ne.0)call trnit('\\J','\\M\\J',
     & bufdim,bufmax,bufstr,bufmx0,bufst0,use2,fndct,subct)

c     write the new .latex2html-init file
      if(use2.eq.0)then
         call writfu('new.latex2html-init',19,2,bufdim,bufmax,bufstr)
      else
         call writfu('new.latex2html-init',19,2,bufdim,bufmx0,bufst0)
      endif

c     write the new defaults.sub file
      call opennw(2,'defaults.new')
      do 1990 ot=1,otmax
         write(2,10,err=9910)org(ot)(1:orgmax(ot))
         if(trnmax(ot).gt.0)then
            write(2,10,err=9910)trn(ot)(1:trnmax(ot))
         else
            write(2,10,err=9910)
         endif
 1990 continue
      close(2,err=9910)

      goto 9900

 2000 if(argt(2)(1:argtl(2)).ne.'updown')goto 2200

c *****************************************************************************
c     updown: change up and down links
c *****************************************************************************

c     read the .latex2html-init file into memory

c     read the file into storage
      call readfu('.latex2html-init',16,2,bufdim,bufmx5,bufst5)
      use2=0

c     convert crlf into lf
      call trnit('\\M\\J','\\J',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,crlf)
      call trnit('\\M\\J','\\J',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,itemp)

c     find the value of subdir
      call trnit('$NO_SUBDIR\\?\\+=\\?\\&\\+\\5\\''\\*;','\\s',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $NO_SUBDIR is not defined!')
      if(fndct.gt.1)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $NO_SUBDIR multiply defined!')
      subdir=0
      call trnit('$NO_SUBDIR\\?\\+=\\?\\+1\\?\\+;','\\f',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
      call trnit('$NO_SUBDIR\\?\\+=\\?\\+0\\?\\+;','\\f',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,subdir,subct)
      if(fndct+subdir.ne.1)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $NO_SUBDIR is not set to either 0 or 1!')
      call trnit('\\d',' ',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)

c     find the value of EXTERNAL_UP_LINK
      call trnit('$EXTERNAL_UP_LINK\\?\\+=\\?\\+''\\?\\~''''','\\s',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $EXTERNAL_UP_LINK is not defined!')
      if(fndct.gt.1)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $EXTERNAL_UP_LINK multiply defined!')
      call trnit('''\\?\\~''''','\\s',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.ne.1 .or. bufmx5.lt.2)
     & call out('*** wizhlp: program error!')
      call set1(bufdim,bufmx5,bufst5,bufmx2,bufst2,use2)

c     ask for the new up link and set it
      line2(1:1)=' '
      line2l=1
      if(bufmx5.gt.2)then
         line2l=min(80,bufmx5-2)
         line2(1:line2l)=bufln5(2:line2l+1)
      endif
      call type('uplink')
      call askurl(subdir,
     & 'Please enter the url of the external "up" link:',
     & line2(1:line2l),line,linelt)
      if(linelt.gt.0)then
         if(linelt.eq.1 .and. line(1:1).eq.' ')then
            bufmx5=2
         else
            bufmx5=linelt+2
            if(bufmx5.gt.bufdml(lev))
     &       call out('*** wizhlp: out of storage!')
            bufln5(2:bufmx5-1)=line(1:linelt)
         endif
         bufst5(bufmx5)=''''
      endif
      havlnk=0
      if(bufmx5.gt.2)havlnk=1
      call trnit('\\d',' ',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)

c     find the value of EXTERNAL_UP_TITLE
      call trnit('$EXTERNAL_UP_TITLE\\?\\+=\\?\\+''\\?\\~''''','\\s',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $EXTERNAL_UP_TITLE is not defined!')
      if(fndct.gt.1)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $EXTERNAL_UP_TITLE multiply defined!')
      call trnit('''\\?\\~''''','\\s',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.ne.1 .or. bufmx5.lt.2)
     & call out('*** wizhlp: program error!')
      call set1(bufdim,bufmx5,bufst5,bufmx2,bufst2,use2)

c     ask for the new up title and set it
      if(havlnk.eq.0)then
         bufmx5=2
         bufst5(2)=''''
         goto 2120
      endif
      call out2(' ')
      call out2('Please enter the title of the external "up" link:')
 2110 line='Title: '
      if(bufmx5.gt.2)then
         line(8:79)=bufln5(2:min(bufmx5-1,72))
         if(bufmx5-1.gt.72)line(77:79)='...'
      endif
      line2=line
      call in2(line,linelt)
      if(index(line(1:linelt),'''').gt.0)then
         call out(
     &    '** Single quotes are not supported.  Use double quotes.')
         goto 2110
      endif
      if(line(1:linelt).ne.line2(8:79))then
         if(linelt.eq.1 .and. line(1:1).eq.' ')then
            bufmx5=2
         else
            bufmx5=linelt+2
            if(bufmx5.gt.bufdml(lev))
     &       call out('*** wizhlp: out of storage!')
            bufln5(2:bufmx5-1)=line(1:linelt)
         endif
         bufst5(bufmx5)=''''
      endif
 2120 call trnit('\\d',' ',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)

c     find the value of EXTERNAL_PREV_LINK
      call trnit('$EXTERNAL_PREV_LINK\\?\\+=\\?\\+''\\?\\~''''','\\s',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0)then
         call out2('** wizhlp: .latex2html-init is corrupt '//
     &    'or out of date: $EXTERNAL_PREV_LINK is')
         call out2('   not defined.  To set the other links, '//
     &    'you will need to clear the web pages')
         call out2('   with the "clrl2h all" command, or at '//
     &    'least delete .latex2html-init,')
         call out2('   followed by recreation of the web pages '//
     &    'using "l2h" or "makel2h".')
         call trnit('\\d',' ',
     &    bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
         goto 2190
      endif
      if(fndct.gt.1)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $EXTERNAL_PREV_LINK multiply defined!')
      call trnit('''\\?\\~''''','\\s',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.ne.1 .or. bufmx5.lt.2)
     & call out('*** wizhlp: program error!')
      call set1(bufdim,bufmx5,bufst5,bufmx2,bufst2,use2)

c     ask for the new previous link and set it
      line2(1:1)=' '
      line2l=1
      if(bufmx5.gt.2)then
         line2l=min(80,bufmx5-2)
         line2(1:line2l)=bufln5(2:line2l+1)
      endif
      call type('downlink')
      call askurl(subdir,
     & 'Please enter the url of the external "previous" link:',
     & line2(1:line2l),line,linelt)
      if(linelt.gt.0)then
         if(linelt.eq.1 .and. line(1:1).eq.' ')then
            bufmx5=2
         else
            bufmx5=linelt+2
            if(bufmx5.gt.bufdml(lev))
     &       call out('*** wizhlp: out of storage!')
            bufln5(2:bufmx5-1)=line(1:linelt)
         endif
         bufst5(bufmx5)=''''
      endif
      havlnk=0
      if(bufmx5.gt.2)havlnk=1
      call trnit('\\d',' ',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)

c     find the value of EXTERNAL_PREV_TITLE
      call trnit('$EXTERNAL_PREV_TITLE\\?\\+=\\?\\+''\\?\\~''''','\\s',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $EXTERNAL_PREV_TITLE is not defined!')
      if(fndct.gt.1)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $EXTERNAL_PREV_TITLE multiply defined!')
      call trnit('''\\?\\~''''','\\s',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.ne.1 .or. bufmx5.lt.2)
     & call out('*** wizhlp: program error!')
      call set1(bufdim,bufmx5,bufst5,bufmx2,bufst2,use2)

c     ask for the new previous title and set it
      if(havlnk.eq.0)then
         bufmx5=2
         bufst5(2)=''''
         goto 2140
      endif
      call out2(' ')
      call out2(
     & 'Please enter the title of the external "previous" link:')
 2130 line='Title: '
      if(bufmx5.gt.2)then
         line(8:79)=bufln5(2:min(bufmx5-1,72))
         if(bufmx5-1.gt.72)line(77:79)='...'
      endif
      line2=line
      call in2(line,linelt)
      if(index(line(1:linelt),'''').gt.0)then
         call out(
     &    '** Single quotes are not supported.  Use double quotes.')
         goto 2130
      endif
      if(line(1:linelt).ne.line2(8:79))then
         if(linelt.eq.1 .and. line(1:1).eq.' ')then
            bufmx5=2
         else
            bufmx5=linelt+2
            if(bufmx5.gt.bufdml(lev))
     &       call out('*** wizhlp: out of storage!')
            bufln5(2:bufmx5-1)=line(1:linelt)
         endif
         bufst5(bufmx5)=''''
      endif
 2140 call trnit('\\d',' ',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)

c     find the value of EXTERNAL_DOWN_LINK
      call trnit('$EXTERNAL_DOWN_LINK\\?\\+=\\?\\+''\\?\\~''''','\\s',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $EXTERNAL_DOWN_LINK is not defined!')
      if(fndct.gt.1)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $EXTERNAL_DOWN_LINK multiply defined!')
      call trnit('''\\?\\~''''','\\s',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.ne.1 .or. bufmx5.lt.2)
     & call out('*** wizhlp: program error!')
      call set1(bufdim,bufmx5,bufst5,bufmx2,bufst2,use2)

c     ask for the new next link and set it
      line2(1:1)=' '
      line2l=1
      if(bufmx5.gt.2)then
         line2l=min(80,bufmx5-2)
         line2(1:line2l)=bufln5(2:line2l+1)
      endif
      call type('downlink')
      call askurl(subdir,
     & 'Please enter the url of the external "next" link:',
     & line2(1:line2l),line,linelt)
      if(linelt.gt.0)then
         if(linelt.eq.1 .and. line(1:1).eq.' ')then
            bufmx5=2
         else
            bufmx5=linelt+2
            if(bufmx5.gt.bufdml(lev))
     &       call out('*** wizhlp: out of storage!')
            bufln5(2:bufmx5-1)=line(1:linelt)
         endif
         bufst5(bufmx5)=''''
      endif
      havlnk=0
      if(bufmx5.gt.2)havlnk=1
      call trnit('\\d',' ',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)

c     find the value of EXTERNAL_DOWN_TITLE
      call trnit('$EXTERNAL_DOWN_TITLE\\?\\+=\\?\\+''\\?\\~''''','\\s',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.le.0)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $EXTERNAL_DOWN_TITLE is not defined!')
      if(fndct.gt.1)call out('*** wizhlp: .latex2html-init is '//
     & 'corrupt: $EXTERNAL_DOWN_TITLE multiply defined!')
      call trnit('''\\?\\~''''','\\s',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)
      if(fndct.ne.1 .or. bufmx5.lt.2)
     & call out('*** wizhlp: program error!')
      call set1(bufdim,bufmx5,bufst5,bufmx2,bufst2,use2)

c     ask for the new next title and set it
      if(havlnk.eq.0)then
         bufmx5=2
         bufst5(2)=''''
         goto 2160
      endif
      call out2(' ')
      call out2(
     & 'Please enter the title of the external "next" link:')
 2150 line='Title: '
      if(bufmx5.gt.2)then
         line(8:79)=bufln5(2:min(bufmx5-1,72))
         if(bufmx5-1.gt.72)line(77:79)='...'
      endif
      line2=line
      call in2(line,linelt)
      if(index(line(1:linelt),'''').gt.0)then
         call out(
     &    '** Single quotes are not supported.  Use double quotes.')
         goto 2150
      endif
      if(line(1:linelt).ne.line2(8:79))then
         if(linelt.eq.1 .and. line(1:1).eq.' ')then
            bufmx5=2
         else
            bufmx5=linelt+2
            if(bufmx5.gt.bufdml(lev))
     &       call out('*** wizhlp: out of storage!')
            bufln5(2:bufmx5-1)=line(1:linelt)
         endif
         bufst5(bufmx5)=''''
      endif
 2160 call trnit('\\d',' ',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)

c     convert lf into crlf
 2190 if(crlf.ne.0)call trnit('\\J','\\M\\J',
     & bufdim,bufmx5,bufst5,bufmx2,bufst2,use2,fndct,subct)

c     write the new .latex2html-init file
      if(use2.eq.0)then
         call writfu('new.latex2html-init',19,2,bufdim,bufmx5,bufst5)
      else
         call writfu('new.latex2html-init',19,2,bufdim,bufmx2,bufst2)
      endif

      goto 9900

 2200 continue

c     keyword not found
      call out(
     & '*** wizhlp: unrecognized task "'//argt(2)(1:argtl(2))//'"!')

c     exit
 9900 call exit(0)

c     file create errors
 9910 call out('*** wizhlp: Unable to write to file!')
c     inquire errors
 9920 call out('*** wizhlp: Unable to look for files!')
c     file read errors
 9950 call encint(linect,cnuml,cnum)
      call out('*** wizhlp: Error reading defaults.sub, line '//
     & cnum(1:cnuml)//'!')
c     print usage
 9990 call out('Usage: wizhlp path task [relevant parameters]')
      call errxit
      end
